/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonmemory_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return pattern9 (); /* [-1, 3] */
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!combine_pseudo_register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  switch (REGNO (x3))
    {
    case 25:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_QQmode:
          if (GET_MODE (x2) != E_QQmode
              || GET_MODE (x3) != E_QQmode
              || GET_MODE (x4) != E_QQmode)
            return -1;
          return 0;

        case E_UQQmode:
          if (GET_MODE (x2) != E_UQQmode
              || GET_MODE (x3) != E_UQQmode
              || GET_MODE (x4) != E_UQQmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 26:
      res = pattern24 (x1, 
22);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case 24:
      if (REGNO (x4) != 18)
        return -1;
      res = pattern25 (x1, 
22);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || pattern34 (x1, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern38 (x3);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  return pattern46 (x1); /* [-1, 5] */
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x2);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 6;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 7;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      return pattern61 (x1, 
E_QQmode); /* [-1, 0] */

    case E_HQmode:
      if (pattern61 (x1, 
E_HQmode) != 0)
        return -1;
      return 1;

    case E_HAmode:
      if (pattern61 (x1, 
E_HAmode) != 0)
        return -1;
      return 2;

    case E_SAmode:
      if (pattern61 (x1, 
E_SAmode) != 0)
        return -1;
      return 3;

    case E_SQmode:
      if (pattern61 (x1, 
E_SQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      return pattern70 (x1); /* [-1, 6] */

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 7; /* [7, 13] */
      return -1;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern61 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern61 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern53 (x3, pnum_clobbers, 
E_PSImode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern61 (x3, 
E_SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      return 0;

    case ZERO_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT)
            return -1;
          return 1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 2; /* [2, 7] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          x6 = XEXP (x1, 1);
          res = pattern82 (x6);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 10; /* [10, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern101 (rtx x1, unsigned int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i4
      || GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i4
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  return pattern100 (x6, 
i1, 
i2); /* [-1, 0] */
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_QImode)
      || !scratch_or_dreg_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return pattern41 (x1); /* [-1, 1] */
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (SUBREG_BYTE (x1))
    {
    case 0:
      x2 = XEXP (x1, 0);
      switch (GET_CODE (x2))
        {
        case ASHIFT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 0;

            case ZERO_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1;

            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_HImode)
                  || !nonimmediate_operand (operands[0], E_QImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case ASHIFTRT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != CONST_INT
              || XWINT (x4, 0) != 128L)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != AND
              || GET_MODE (x3) != E_QImode)
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case ZERO_EXTRACT:
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_0_to_15_operand (operands[2], E_QImode))
                return -1;
              return 4;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !const_0_to_23_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_0_to_31_operand (operands[2], E_QImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != LO_SUM
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nonmemory_operand (operands[1], E_QImode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22)
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nop_general_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern179 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern179 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern179 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern179 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || !register_operand (operands[3], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern193 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !pseudo_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !pseudo_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern202 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  return 0;
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || GET_MODE (x5) != E_DQmode)
            return -1;
          return 0;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || GET_MODE (x5) != E_DAmode)
            return -1;
          return 1;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || GET_MODE (x5) != E_TAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || !const_operand (operands[0], E_DQmode))
            return -1;
          return 3;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || !const_operand (operands[0], E_DAmode))
            return -1;
          return 4;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || !const_operand (operands[0], E_TAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  if (!const_int_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  x12 = XEXP (x4, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern271 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x11;
      return pattern268 (); /* [-1, 1] */

    case SIGN_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern270 (x12);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern270 (x12);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_HImode))
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_HImode))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern299 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 22
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 18
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 30
      || GET_MODE (x10) != E_HImode
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 1;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 2;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 3;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 4;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 5;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 6;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 7;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 8;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern339 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  if (!const_int_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x7, 1);
  operands[5] = x9;
  if (!const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern344 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern341 (x1); /* [-1, 2] */
}

int
pattern351 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x4, 0);
  operands[2] = x10;
  switch (GET_MODE (x7))
    {
    case E_HImode:
      if (!register_operand (operands[3], E_HImode)
          || GET_MODE (x8) != E_HImode
          || !register_operand (operands[4], E_QImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x4) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[3], E_PSImode)
          || GET_MODE (x8) != E_PSImode
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x4) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          if (!register_operand (operands[4], E_QImode)
              || !register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[4], E_HImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[3], E_SImode)
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          if (!register_operand (operands[4], E_QImode)
              || !register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[4], E_HImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[4], E_PSImode)
              || !register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern381 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[3] = x6;
  x7 = XEXP (x5, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != IF_THEN_ELSE)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != LABEL_REF)
    return -1;
  x11 = XEXP (x9, 2);
  if (GET_CODE (x11) != PC)
    return -1;
  x12 = XEXP (x8, 0);
  if (GET_CODE (x12) != PC)
    return -1;
  x13 = XEXP (x10, 0);
  operands[2] = x13;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  return pattern388 (x4, 
i1); /* [-1, 5] */
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == REG
      && REGNO (x2) == 22)
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (pattern159 (x2))
        {
        case 0:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 5; /* load_qi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 20; /* *load_qi_libgcc */
            }
          break;

        case 1:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 6; /* load_qq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 21; /* *load_qq_libgcc */
            }
          break;

        case 2:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 7; /* load_uqq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 22; /* *load_uqq_libgcc */
            }
          break;

        case 3:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 8; /* load_hi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 23; /* *load_hi_libgcc */
            }
          break;

        case 4:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 9; /* load_hq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 24; /* *load_hq_libgcc */
            }
          break;

        case 5:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 10; /* load_uhq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 25; /* *load_uhq_libgcc */
            }
          break;

        case 6:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 11; /* load_ha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 26; /* *load_ha_libgcc */
            }
          break;

        case 7:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 12; /* load_uha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 27; /* *load_uha_libgcc */
            }
          break;

        case 8:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 13; /* load_si_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 28; /* *load_si_libgcc */
            }
          break;

        case 9:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 14; /* load_sq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 29; /* *load_sq_libgcc */
            }
          break;

        case 10:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 15; /* load_usq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 30; /* *load_usq_libgcc */
            }
          break;

        case 11:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 16; /* load_sa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 31; /* *load_sa_libgcc */
            }
          break;

        case 12:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 17; /* load_usa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 32; /* *load_usa_libgcc */
            }
          break;

        case 13:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 18; /* load_sf_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 33; /* *load_sf_libgcc */
            }
          break;

        case 14:
          if (
#line 572 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 19; /* load_psi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 34; /* *load_psi_libgcc */
            }
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern122 (x3))
    {
    case 0:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 35; /* fxmovqi_A */

    case 1:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 36; /* fxmovqq_A */

    case 2:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 37; /* fxmovuqq_A */

    case 3:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 38; /* fxmovhi_A */

    case 4:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 39; /* fxmovhq_A */

    case 5:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 40; /* fxmovuhq_A */

    case 6:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 41; /* fxmovha_A */

    case 7:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 42; /* fxmovuha_A */

    case 8:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 43; /* fxmovsi_A */

    case 9:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 44; /* fxmovsq_A */

    case 10:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 45; /* fxmovusq_A */

    case 11:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 46; /* fxmovsa_A */

    case 12:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 47; /* fxmovusa_A */

    case 13:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 48; /* fxmovsf_A */

    case 14:
      if (!
#line 599 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 49; /* fxmovpsi_A */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern68 (x2))
        {
        case 0:
          return 172; /* *strlenhi_split */

        case 1:
          return 1011; /* insert_bits */

        case 2:
          return 3126; /* roundqq3_const */

        case 3:
          return 3127; /* roundhq3_const */

        case 4:
          return 3128; /* roundha3_const */

        case 5:
          return 3129; /* roundsa3_const */

        case 6:
          return 3130; /* roundsq3_const */

        case 7:
          return 3131; /* rounduqq3_const */

        case 8:
          return 3132; /* rounduhq3_const */

        case 9:
          return 3133; /* rounduha3_const */

        case 10:
          return 3134; /* roundusa3_const */

        case 11:
          return 3135; /* roundusq3_const */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 4:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9703 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1057; /* fmul_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9718 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1058; /* *fmul_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9729 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1059; /* *fmul.call_split */
            }
          if (!
#line 9744 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1060; /* *fmul.call */

        case 5:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9775 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1061; /* fmuls_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9790 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1062; /* *fmuls_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9801 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1063; /* *fmuls.call_split */
            }
          if (!
#line 9816 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1064; /* *fmuls.call */

        case 6:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9847 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1065; /* fmulsu_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9862 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1066; /* *fmulsu_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9873 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1067; /* *fmulsu.call_split */
            }
          if (!
#line 9888 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1068; /* *fmulsu.call */

        case 8:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != REG)
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 24
              || GET_MODE (x5) != E_QImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG)
            return -1;
          switch (REGNO (x4))
            {
            case 22:
              if (REGNO (x3) != 24)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_QQmode:
                  if (GET_MODE (x2) != E_QQmode
                      || GET_MODE (x4) != E_QQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3146; /* *roundqq3.libgcc_split */

                case E_UQQmode:
                  if (GET_MODE (x2) != E_UQQmode
                      || GET_MODE (x4) != E_UQQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3147; /* *rounduqq3.libgcc_split */

                case E_HQmode:
                  if (GET_MODE (x2) != E_HQmode
                      || GET_MODE (x4) != E_HQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3150; /* *roundhq3.libgcc_split */

                case E_UHQmode:
                  if (GET_MODE (x2) != E_UHQmode
                      || GET_MODE (x4) != E_UHQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3151; /* *rounduhq3.libgcc_split */

                case E_HAmode:
                  if (GET_MODE (x2) != E_HAmode
                      || GET_MODE (x4) != E_HAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3152; /* *roundha3.libgcc_split */

                case E_UHAmode:
                  if (GET_MODE (x2) != E_UHAmode
                      || GET_MODE (x4) != E_UHAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3153; /* *rounduha3.libgcc_split */

                default:
                  return -1;
                }

            case 18:
              if (REGNO (x3) != 22)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_SQmode:
                  if (GET_MODE (x2) != E_SQmode
                      || GET_MODE (x4) != E_SQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3158; /* *roundsq3.libgcc_split */

                case E_USQmode:
                  if (GET_MODE (x2) != E_USQmode
                      || GET_MODE (x4) != E_USQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3159; /* *roundusq3.libgcc_split */

                case E_SAmode:
                  if (GET_MODE (x2) != E_SAmode
                      || GET_MODE (x4) != E_SAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3160; /* *roundsa3.libgcc_split */

                case E_USAmode:
                  if (GET_MODE (x2) != E_USAmode
                      || GET_MODE (x4) != E_USAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3161; /* *roundusa3.libgcc_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 3
          || GET_MODE (x2) != E_QImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != IOR
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      if (!register_operand (operands[3], E_QImode)
          || !
#line 11130 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
        return -1;
      *pnum_clobbers = 1;
      return 1495; /* *nzb=1.ior.ashift */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (pattern75 (x1, pnum_clobbers))
        {
        case 0:
          return 618; /* andqi3 */

        case 1:
          *pnum_clobbers = 1;
          return 620; /* andhi3 */

        case 2:
          *pnum_clobbers = 1;
          return 622; /* andpsi3 */

        case 3:
          *pnum_clobbers = 1;
          return 624; /* andsi3 */

        default:
          break;
        }
      if (GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern216 (x2))
        {
        case 0:
          if (!
#line 10632 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1210; /* *extract.subreg.bit */

        case 1:
          if (!
#line 10632 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1212; /* *extract.subreg.bit */

        case 2:
          if (!
#line 10632 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1214; /* *extract.subreg.bit */

        case 3:
          if (!
#line 10632 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1211; /* *extract.subreg.bit */

        case 4:
          if (!
#line 10632 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1213; /* *extract.subreg.bit */

        case 5:
          if (!
#line 10632 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1215; /* *extract.subreg.bit */

        default:
          return -1;
        }

    case MEM:
      if (pattern40 (x1) != 0
          || !single_zero_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      return 980; /* *cbi */

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern77 (x2))
        {
        case 0:
          return 1182; /* *insv.any_shift.qi_split */

        case 1:
          return 1185; /* *insv.any_shift.hi_split */

        case 2:
          return 1188; /* *insv.any_shift.psi_split */

        case 3:
          return 1191; /* *insv.any_shift.si_split */

        case 4:
          if (!
#line 10988 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && avr_nonzero_bits_lsr_operands_p (AND, operands)))
            return -1;
          return 1481; /* *nzb=1.and.lsr_split */

        case 5:
          if (!
#line 11038 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && avr_nonzero_bits_lsr_operands_p (AND, operands)))
            return -1;
          return 1487; /* *nzb=1.and.lsr.not_split */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern78 (x2))
        {
        case 0:
          return 1183; /* *insv.any_shift.qi_split */

        case 1:
          return 1186; /* *insv.any_shift.hi_split */

        case 2:
          return 1189; /* *insv.any_shift.psi_split */

        case 3:
          return 1192; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern78 (x2))
        {
        case 0:
          return 1184; /* *insv.any_shift.qi_split */

        case 1:
          return 1187; /* *insv.any_shift.hi_split */

        case 2:
          return 1190; /* *insv.any_shift.psi_split */

        case 3:
          return 1193; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern136 (x2))
        {
        case 0:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1457; /* *map.and1-to-skip.qi */

        case 1:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1461; /* *map.and1-to-skip.qi */

        case 2:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1465; /* *map.and1-to-skip.qi */

        case 3:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1469; /* *map.and1-to-skip.qi */

        case 4:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1458; /* *map.and1-to-skip.hi */

        case 5:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1462; /* *map.and1-to-skip.hi */

        case 6:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1466; /* *map.and1-to-skip.hi */

        case 7:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1470; /* *map.and1-to-skip.hi */

        case 8:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1459; /* *map.and1-to-skip.psi */

        case 9:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1463; /* *map.and1-to-skip.psi */

        case 10:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1467; /* *map.and1-to-skip.psi */

        case 11:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1471; /* *map.and1-to-skip.psi */

        case 12:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1460; /* *map.and1-to-skip.si */

        case 13:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1464; /* *map.and1-to-skip.si */

        case 14:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1468; /* *map.and1-to-skip.si */

        case 15:
          if (!
#line 10914 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1472; /* *map.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10943 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (AND == IOR || AND == XOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1475; /* *nzb=1.and.zerox_split */

        case 1:
          if (!
#line 11012 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && (AND == IOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1484; /* *nzb=1.and.zerox.not_split */

        default:
          return -1;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11062 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (AND == IOR || AND == XOR
       || nonzero_bits (operands[2], QImode) == 1)))
        return -1;
      return 1490; /* *nzb=1.and.ge0_split */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 258; /* *subhi3.sign_extend.qi */

        case 1:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 260; /* *subpsi3.sign_extend.qi */

        case 2:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 264; /* *subpsi3.sign_extend.hi */

        case 3:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 262; /* *subsi3.sign_extend.qi */

        case 4:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 266; /* *subsi3.sign_extend.hi */

        case 5:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 268; /* *subsi3.sign_extend.psi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 259; /* *subhi3.zero_extend.qi */

        case 1:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 261; /* *subpsi3.zero_extend.qi */

        case 2:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 265; /* *subpsi3.zero_extend.hi */

        case 3:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 263; /* *subsi3.zero_extend.qi */

        case 4:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 267; /* *subsi3.zero_extend.hi */

        case 5:
          if (!
#line 2034 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 269; /* *subsi3.zero_extend.psi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_PSImode:
              if (pattern321 (x3, 
E_PSImode) == 0
                  && 
#line 2088 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 273; /* *subpsi3 */
              break;

            case E_QImode:
              if (pattern308 (x3, 
E_QImode) == 0
                  && 
#line 2115 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 277; /* *subqi3 */
              break;

            case E_QQmode:
              if (pattern308 (x3, 
E_QQmode) == 0
                  && 
#line 2115 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 278; /* *subqq3 */
              break;

            case E_UQQmode:
              if (pattern308 (x3, 
E_UQQmode) == 0
                  && 
#line 2115 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 279; /* *subuqq3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern308 (x3, 
E_HImode) != 0)
            return -1;
          return 280; /* subhi3 */

        case E_HQmode:
          if (pattern308 (x3, 
E_HQmode) != 0)
            return -1;
          return 281; /* subhq3 */

        case E_UHQmode:
          if (pattern308 (x3, 
E_UHQmode) != 0)
            return -1;
          return 282; /* subuhq3 */

        case E_HAmode:
          if (pattern308 (x3, 
E_HAmode) != 0)
            return -1;
          return 283; /* subha3 */

        case E_UHAmode:
          if (pattern308 (x3, 
E_UHAmode) != 0)
            return -1;
          return 284; /* subuha3 */

        case E_SImode:
          if (pattern308 (x3, 
E_SImode) != 0)
            return -1;
          return 290; /* subsi3 */

        case E_SQmode:
          if (pattern308 (x3, 
E_SQmode) != 0)
            return -1;
          return 291; /* subsq3 */

        case E_USQmode:
          if (pattern308 (x3, 
E_USQmode) != 0)
            return -1;
          return 292; /* subusq3 */

        case E_SAmode:
          if (pattern308 (x3, 
E_SAmode) != 0)
            return -1;
          return 293; /* subsa3 */

        case E_USAmode:
          if (pattern308 (x3, 
E_USAmode) != 0)
            return -1;
          return 294; /* subusa3 */

        default:
          return -1;
        }

    case GE:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 348; /* *subqi3.ge0 */

        case 1:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 356; /* *subqi3.ge0 */

        case 2:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 364; /* *subqi3.ge0 */

        case 3:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 372; /* *subqi3.ge0 */

        case 4:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 350; /* *subhi3.ge0 */

        case 5:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 358; /* *subhi3.ge0 */

        case 6:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 366; /* *subhi3.ge0 */

        case 7:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 374; /* *subhi3.ge0 */

        case 8:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 352; /* *subpsi3.ge0 */

        case 9:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 360; /* *subpsi3.ge0 */

        case 10:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 368; /* *subpsi3.ge0 */

        case 11:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 376; /* *subpsi3.ge0 */

        case 12:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 354; /* *subsi3.ge0 */

        case 13:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 362; /* *subsi3.ge0 */

        case 14:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 370; /* *subsi3.ge0 */

        case 15:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 378; /* *subsi3.ge0 */

        default:
          return -1;
        }

    case LT:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 349; /* *subqi3.lt0 */

        case 1:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 357; /* *subqi3.lt0 */

        case 2:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 365; /* *subqi3.lt0 */

        case 3:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 373; /* *subqi3.lt0 */

        case 4:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 351; /* *subhi3.lt0 */

        case 5:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 359; /* *subhi3.lt0 */

        case 6:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 367; /* *subhi3.lt0 */

        case 7:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 375; /* *subhi3.lt0 */

        case 8:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 353; /* *subpsi3.lt0 */

        case 9:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 361; /* *subpsi3.lt0 */

        case 10:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 369; /* *subpsi3.lt0 */

        case 11:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 377; /* *subpsi3.lt0 */

        case 12:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 355; /* *subsi3.lt0 */

        case 13:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 363; /* *subsi3.lt0 */

        case 14:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 371; /* *subsi3.lt0 */

        case 15:
          if (!
#line 2370 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 379; /* *subsi3.lt0 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      switch (pattern234 (x3))
        {
        case 0:
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 36
                  || GET_MODE (x7) != E_CCmode
                  || !
#line 2633 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 493; /* *msubqi4 */

            case CONST_INT:
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2662 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 495; /* *msubqi4.const */

            default:
              return -1;
            }

        case 1:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              if (pattern362 (x1) != 0
                  || !
#line 2745 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 502; /* *msubqihi4 */

            case ZERO_EXTEND:
              if (pattern362 (x1) != 0
                  || !
#line 2811 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              return 511; /* *sumsubqihi4 */

            case CONST_INT:
              operands[2] = x8;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode))
                return -1;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2877 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 515; /* *msubqihi4.sconst */
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2968 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              return 520; /* *sumsubqihi4.uconst */

            default:
              return -1;
            }

        case 2:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              if (pattern362 (x1) != 0
                  || !
#line 2745 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 503; /* *umsubqihi4 */

            case SIGN_EXTEND:
              if (pattern362 (x1) != 0
                  || !
#line 2811 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              return 510; /* *usmsubqihi4 */

            case CONST_INT:
              operands[2] = x8;
              if (!u8_operand (operands[2], E_HImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2877 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 516; /* *umsubqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern222 (x3) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!scratch_operand (operands[4], E_QImode))
        return -1;
      x9 = XEXP (x4, 0);
      switch (pattern352 (x9))
        {
        case 0:
          if (!
#line 2900 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 517; /* *umsubqihi4.uconst.ashift */

        case 1:
          if (!
#line 2924 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 518; /* *msubqihi4.sconst.ashift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ZERO_EXTEND
          || GET_MODE (x6) != E_HImode
          || pattern169 (x1, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 1783 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 192; /* *udiff_widenqihi3 */

    case REG:
    case SUBREG:
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      res = recog_43 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || pattern204 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
          switch (pattern330 (x3))
            {
            case 0:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3203; /* *subdi3_insn */

            case 1:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3204; /* *subdq3_insn */

            case 2:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3205; /* *subudq3_insn */

            case 3:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3206; /* *subda3_insn */

            case 4:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3207; /* *subuda3_insn */

            case 5:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3208; /* *subta3_insn */

            case 6:
              if (!
#line 224 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3209; /* *subuta3_insn */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
          switch (pattern331 (x3))
            {
            case 0:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3217; /* *subdi3_const_insn */

            case 1:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3218; /* *subdq3_const_insn */

            case 2:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3219; /* *subudq3_const_insn */

            case 3:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3220; /* *subda3_const_insn */

            case 4:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3221; /* *subuda3_const_insn */

            case 5:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3222; /* *subta3_const_insn */

            case 6:
              if (!
#line 249 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3223; /* *subuta3_const_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_60 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_58 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_56 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_65 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_59 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_68 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_64 (x1, insn, pnum_clobbers);

    case DIV:
      if (pnum_clobbers != NULL)
        {
          switch (pattern141 (x1, 
MOD))
            {
            case 0:
              *pnum_clobbers = 4;
              return 584; /* divmodqi4 */

            case 1:
              *pnum_clobbers = 4;
              return 590; /* divmodhi4 */

            case 2:
              *pnum_clobbers = 2;
              return 606; /* divmodpsi4 */

            case 3:
              *pnum_clobbers = 4;
              return 612; /* divmodsi4 */

            default:
              break;
            }
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern146 (x1, pnum_clobbers, 
MOD))
        {
        case 0:
          *pnum_clobbers = 2;
          return 585; /* *divmodqi4_call_split */

        case 1:
          *pnum_clobbers = 2;
          return 591; /* *divmodhi4_call_split */

        case 2:
          *pnum_clobbers = 3;
          return 607; /* *divmodpsi4_call_split */

        case 3:
          *pnum_clobbers = 2;
          return 613; /* *divmodsi4_call_split */

        case 4:
          return 3095; /* *divqq3.call_split */

        case 5:
          return 3097; /* *divuqq3.call_split */

        default:
          return -1;
        }

    case UDIV:
      if (pnum_clobbers != NULL)
        {
          switch (pattern141 (x1, 
UMOD))
            {
            case 0:
              *pnum_clobbers = 4;
              return 587; /* udivmodqi4 */

            case 1:
              *pnum_clobbers = 4;
              return 593; /* udivmodhi4 */

            case 2:
              *pnum_clobbers = 2;
              return 609; /* udivmodpsi4 */

            case 3:
              *pnum_clobbers = 4;
              return 615; /* udivmodsi4 */

            default:
              break;
            }
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern146 (x1, pnum_clobbers, 
UMOD))
        {
        case 0:
          *pnum_clobbers = 1;
          return 588; /* *udivmodqi4_call_split */

        case 1:
          *pnum_clobbers = 2;
          return 594; /* *udivmodhi4_call_split */

        case 2:
          *pnum_clobbers = 3;
          return 610; /* *udivmodpsi4_call_split */

        case 3:
          *pnum_clobbers = 2;
          return 616; /* *udivmodsi4_call_split */

        case 4:
          return 3094; /* *udivqq3.call_split */

        case 5:
          return 3096; /* *udivuqq3.call_split */

        default:
          return -1;
        }

    case AND:
      return recog_66 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern98 (x1, pnum_clobbers))
        {
        case 0:
          if (nonmemory_operand (operands[2], E_QImode)
              && pattern262 (x1, 
E_QImode) == 0
              && 
#line 4643 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 627; /* *iorqi3 */
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          switch (pattern109 (x3))
            {
            case 0:
              return 628; /* iorhi3 */

            case 1:
              return 630; /* iorpsi3 */

            case 2:
              return 632; /* iorsi3 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10970 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1477; /* *nzb=1.ior.zerox */

        case 2:
          if (!
#line 11090 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1492; /* *nzb=1.ior.zerox.not */

        default:
          return -1;
        }

    case XOR:
      switch (pattern98 (x1, pnum_clobbers))
        {
        case 0:
          if (register_operand (operands[2], E_QImode)
              && pattern262 (x1, 
E_QImode) == 0
              && 
#line 4767 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 635; /* *xorqi3 */
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          switch (pattern109 (x3))
            {
            case 0:
              return 636; /* xorhi3 */

            case 1:
              return 638; /* xorpsi3 */

            case 2:
              return 640; /* xorsi3 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10970 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1476; /* *nzb=1.xor.zerox */

        case 2:
          if (!
#line 11090 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
            return -1;
          *pnum_clobbers = 1;
          return 1491; /* *nzb=1.xor.zerox.not */

        default:
          return -1;
        }

    case ROTATE:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          res = recog_48 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x4) != REG)
            return -1;
          switch (pattern170 (x1))
            {
            case 0:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3335; /* *rotldi3_insn */

            case 1:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3339; /* *rotldq3_insn */

            case 2:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3343; /* *rotludq3_insn */

            case 3:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3347; /* *rotlda3_insn */

            case 4:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3351; /* *rotluda3_insn */

            case 5:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3355; /* *rotlta3_insn */

            case 6:
              if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3359; /* *rotluta3_insn */

            default:
              return -1;
            }

        case CONST_INT:
          if (pattern169 (x1, 
E_QImode) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          switch (XWINT (x4, 0))
            {
            case 1L:
              if (!
#line 8976 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1014; /* *mask1_0x01 */

            case -2L:
              if (!
#line 9052 "../../gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1019; /* *mask1_0xfe */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3333; /* *ashrdi3_insn */

        case 1:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3337; /* *ashrdq3_insn */

        case 2:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3341; /* *ashrudq3_insn */

        case 3:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3345; /* *ashrda3_insn */

        case 4:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3349; /* *ashruda3_insn */

        case 5:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3353; /* *ashrta3_insn */

        case 6:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3357; /* *ashruta3_insn */

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3334; /* *lshrdi3_insn */

        case 1:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3338; /* *lshrdq3_insn */

        case 2:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3342; /* *lshrudq3_insn */

        case 3:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3346; /* *lshrda3_insn */

        case 4:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3350; /* *lshruda3_insn */

        case 5:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3354; /* *lshrta3_insn */

        case 6:
          if (!
#line 642 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3358; /* *lshruta3_insn */

        default:
          return -1;
        }

    case ABS:
      if (pattern99 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 6189 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 782; /* *absqi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6209 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 784; /* *abssf2 */

        default:
          return -1;
        }

    case NEG:
      return recog_62 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_63 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_70 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern171 (x1) != 0)
        return -1;
      return 822; /* n_extendhipsi2 */

    case COMPARE:
      return recog_57 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_61 (x1, insn, pnum_clobbers);

    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!nonmemory_operand (operands[1], E_HImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!general_operand (operands[2], E_HImode))
        return -1;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_HImode))
        return -1;
      return 971; /* call_value_insn */

    case ROTATERT:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT
          || XWINT (x4, 0) != -128L)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern209 (x1, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 9009 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1016; /* *mask1_0x80 */

    case PARITY:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      if (REGNO (x6) == 24)
        {
          switch (pattern225 (x1))
            {
            case 0:
              if (
#line 9140 "../../gcc/config/avr/avr.md"
(!reload_completed))
                return 1022; /* *parityhi2 */
              break;

            case 1:
              if (
#line 9169 "../../gcc/config/avr/avr.md"
(!reload_completed))
                return 1024; /* *parityqihi2.2 */
              break;

            default:
              break;
            }
        }
      if (REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24
          || GET_MODE (x4) != E_HImode)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_HImode
          || !
#line 9207 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1026; /* *parityhi2.libgcc */

    case ZERO_EXTEND:
      return recog_71 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      switch (GET_MODE (x8))
        {
        case E_HImode:
          if (GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || !
#line 9301 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1033; /* *popcounthi2.libgcc */

        case E_QImode:
          if (GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode
              || !
#line 9337 "../../gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1037; /* *popcountqi2.libgcc */

        default:
          return -1;
        }

    case CLZ:
      if (pattern101 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1039; /* *clzhi2.libgcc_split */

    case CTZ:
      if (pattern101 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1043; /* *ctzhi2.libgcc_split */

    case FFS:
      if (pattern101 (x1, 
26, 
E_QImode, 
E_HImode, 
24) != 0)
        return -1;
      return 1047; /* *ffshi2.libgcc_split */

    case BSWAP:
      if (pattern101 (x1, 
36, 
E_CCmode, 
E_SImode, 
22) != 0
          || !
#line 9605 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1053; /* *bswapsi2.libgcc */

    case ZERO_EXTRACT:
      return recog_69 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      return recog_67 (x1, insn, pnum_clobbers);

    case FRACT_CONVERT:
      return recog_55 (x1, insn, pnum_clobbers);

    case UNSIGNED_FRACT_CONVERT:
      return recog_54 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern236 (x3))
        {
        case 0:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3026; /* *ssaddqq3 */
          break;

        case 1:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3028; /* *ssaddhq3 */
          break;

        case 2:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3030; /* *ssaddha3 */
          break;

        case 3:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3032; /* *ssaddsa3 */
          break;

        case 4:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3034; /* *ssaddsq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern237 (x2))
        {
        case 0:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3230; /* *ssadddq3_insn */

        case 1:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3232; /* *ssaddda3_insn */

        case 2:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3234; /* *ssaddta3_insn */

        case 3:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3242; /* *ssadddq3_const_insn */

        case 4:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3244; /* *ssaddda3_const_insn */

        case 5:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3246; /* *ssaddta3_const_insn */

        default:
          return -1;
        }

    case SS_MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern236 (x3))
        {
        case 0:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3027; /* *sssubqq3 */
          break;

        case 1:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3029; /* *sssubhq3 */
          break;

        case 2:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3031; /* *sssubha3 */
          break;

        case 3:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3033; /* *sssubsa3 */
          break;

        case 4:
          if (
#line 137 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3035; /* *sssubsq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern237 (x2))
        {
        case 0:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3231; /* *sssubdq3_insn */

        case 1:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3233; /* *sssubda3_insn */

        case 2:
          if (!
#line 301 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3235; /* *sssubta3_insn */

        case 3:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3243; /* *sssubdq3_const_insn */

        case 4:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3245; /* *sssubda3_const_insn */

        case 5:
          if (!
#line 322 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3247; /* *sssubta3_const_insn */

        default:
          return -1;
        }

    case US_PLUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern238 (x3))
        {
        case 0:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3046; /* *usadduqq3 */
          break;

        case 1:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3048; /* *usadduhq3 */
          break;

        case 2:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3050; /* *usadduha3 */
          break;

        case 3:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3052; /* *usaddusa3 */
          break;

        case 4:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3054; /* *usaddusq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern239 (x2))
        {
        case 0:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3254; /* *usaddudq3_insn */

        case 1:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3256; /* *usadduda3_insn */

        case 2:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3258; /* *usadduta3_insn */

        case 3:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3266; /* *usaddudq3_const_insn */

        case 4:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3268; /* *usadduda3_const_insn */

        case 5:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3270; /* *usadduta3_const_insn */

        default:
          return -1;
        }

    case US_MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern100 (x5, 
36, 
E_CCmode) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (pattern238 (x3))
        {
        case 0:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3047; /* *ussubuqq3 */
          break;

        case 1:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3049; /* *ussubuhq3 */
          break;

        case 2:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3051; /* *ussubuha3 */
          break;

        case 3:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3053; /* *ussubusa3 */
          break;

        case 4:
          if (
#line 162 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return 3055; /* *ussubusq3 */
          break;

        default:
          break;
        }
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern239 (x2))
        {
        case 0:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3255; /* *ussubudq3_insn */

        case 1:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3257; /* *ussubuda3_insn */

        case 2:
          if (!
#line 374 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3259; /* *ussubuta3_insn */

        case 3:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3267; /* *ussubudq3_const_insn */

        case 4:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3269; /* *ussubuda3_const_insn */

        case 5:
          if (!
#line 395 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3271; /* *ussubuta3_const_insn */

        default:
          return -1;
        }

    case SS_NEG:
      if (GET_MODE (x3) == E_QQmode
          && pattern147 (x1) == 0
          && 
#line 200 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return 3057; /* *ssnegqq2 */
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern148 (x1))
        {
        case 0:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3065; /* *ssneghq2 */

        case 1:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3067; /* *ssnegha2 */

        case 2:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3073; /* *ssnegsa2 */

        case 3:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3075; /* *ssnegsq2 */

        default:
          return -1;
        }

    case SS_ABS:
      if (GET_MODE (x3) == E_QQmode
          && pattern147 (x1) == 0
          && 
#line 218 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
        return 3059; /* *ssabsqq2 */
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern148 (x1))
        {
        case 0:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3064; /* *ssabshq2 */

        case 1:
          if (!
#line 252 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3066; /* *ssabsha2 */

        case 2:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3072; /* *ssabssa2 */

        case 3:
          if (!
#line 272 "../../gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3074; /* *ssabssq2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      if (!register_operand (x3, E_QImode)
          || GET_MODE (x2) != E_QImode)
        return NULL;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[2] = x4;
          if (!register_operand (operands[2], E_QImode))
            return NULL;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          operands[1] = x3;
          if (!
#line 4756 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_375 (insn, operands);

        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return NULL;
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) != ZERO_EXTRACT
              || GET_MODE (x5) != E_QImode)
            return NULL;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          x8 = XEXP (x5, 2);
          operands[1] = x8;
          if (!const_0_to_7_operand (operands[1], E_QImode))
            return NULL;
          operands[2] = x3;
          if (!
#line 10086 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_662 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern81 (x2))
        {
        case 0:
          if (!(
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_667 (insn, operands);

        case 1:
          if (!(
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_671 (insn, operands);

        case 2:
          if (!(
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_675 (insn, operands);

        case 3:
          if (!
#line 10992 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1018 (insn, operands);

        case 4:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_691 (insn, operands);

        case 5:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_695 (insn, operands);

        case 6:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_703 (insn, operands);

        case 7:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_699 (insn, operands);

        case 8:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_707 (insn, operands);

        case 9:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_711 (insn, operands);

        case 10:
          if (!
#line 11043 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1024 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern48 (x1))
        {
        case 0:
          if (!(
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_669 (insn, operands);

        case 1:
          if (!(
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_673 (insn, operands);

        case 2:
          if (!(
#line 10152 "../../gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10154 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_677 (insn, operands);

        case 3:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_693 (insn, operands);

        case 4:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_697 (insn, operands);

        case 5:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_705 (insn, operands);

        case 6:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_701 (insn, operands);

        case 7:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_709 (insn, operands);

        case 8:
          if (!(
#line 10198 "../../gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10201 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_713 (insn, operands);

        case 9:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_915 (insn, operands);

        case 10:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_921 (insn, operands);

        case 11:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_933 (insn, operands);

        case 12:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_927 (insn, operands);

        case 13:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_939 (insn, operands);

        case 14:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_945 (insn, operands);

        case 15:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_914 (insn, operands);

        case 16:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_920 (insn, operands);

        case 17:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_932 (insn, operands);

        case 18:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_926 (insn, operands);

        case 19:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_938 (insn, operands);

        case 20:
          if (!(
#line 10794 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10798 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_944 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (pattern3 (x2))
        {
        case 0:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(2 > 1) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_679 (insn, operands);

        case 1:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(3 > 1) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_681 (insn, operands);

        case 2:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(3 > 2) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_685 (insn, operands);

        case 3:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(4 > 1) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_683 (insn, operands);

        case 4:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(4 > 2) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_687 (insn, operands);

        case 5:
          if (!(
#line 10175 "../../gcc/config/avr/avr.md"
(4 > 3) && 
#line 10177 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_689 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x9 = XEXP (x3, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_816 (insn, operands);

            case 1:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_828 (insn, operands);

            case 2:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_840 (insn, operands);

            case 3:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_852 (insn, operands);

            case 4:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_819 (insn, operands);

            case 5:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_831 (insn, operands);

            case 6:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_843 (insn, operands);

            case 7:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_855 (insn, operands);

            case 8:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_822 (insn, operands);

            case 9:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_834 (insn, operands);

            case 10:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_846 (insn, operands);

            case 11:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_858 (insn, operands);

            case 12:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_825 (insn, operands);

            case 13:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_837 (insn, operands);

            case 14:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_849 (insn, operands);

            case 15:
              if (!(
#line 10732 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10735 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_861 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_948 (insn, operands);

            case 1:
              if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_951 (insn, operands);

            case 2:
              if (!(
#line 10813 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10818 "../../gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_954 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern87 (x2))
        {
        case 0:
          if (!(
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_864 (insn, operands);

        case 1:
          if (!(
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_867 (insn, operands);

        case 2:
          if (!(
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_870 (insn, operands);

        case 3:
          if (!(
#line 10757 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10760 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_873 (insn, operands);

        case 4:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_878 (insn, operands);

        case 5:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_884 (insn, operands);

        case 6:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_896 (insn, operands);

        case 7:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_890 (insn, operands);

        case 8:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_902 (insn, operands);

        case 9:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_908 (insn, operands);

        case 10:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_879 (insn, operands);

        case 11:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_885 (insn, operands);

        case 12:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_897 (insn, operands);

        case 13:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_891 (insn, operands);

        case 14:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_903 (insn, operands);

        case 15:
          if (!(
#line 10774 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10778 "../../gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_909 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10948 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1015 (insn, operands);

        case 1:
          if (!
#line 11018 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
            return NULL;
          return gen_split_1021 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11067 "../../gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed))
        return NULL;
      return gen_split_1027 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x3;
      if (ordered_comparison_operator (operands[0], E_VOIDmode))
        {
          res = split_7 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern91 (x1))
        {
        case 0:
          if (!
#line 7631 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_607 (insn, operands);

        case 1:
          if (!
#line 7631 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_608 (insn, operands);

        case 2:
          if (!
#line 7631 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_609 (insn, operands);

        case 3:
          if (!
#line 7631 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_610 (insn, operands);

        case 4:
          if (!
#line 7631 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_611 (insn, operands);

        case 5:
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8145 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_618 (insn, operands);
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8240 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_621 (insn, operands);

        case 6:
          if (low_io_address_operand (operands[1], E_VOIDmode)
              && 
#line 8145 "../../gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_619 (insn, operands);
          if (!high_io_address_operand (operands[1], E_VOIDmode)
              || !
#line 8240 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_622 (insn, operands);

        case 7:
          if (!
#line 7684 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_612 (insn, operands);

        case 8:
          if (!
#line 7684 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_613 (insn, operands);

        case 9:
          if (!
#line 7684 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_614 (insn, operands);

        case 10:
          if (!
#line 7684 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_615 (insn, operands);

        case 11:
          operands[0] = x3;
          if (gelt_operator (operands[0], E_VOIDmode))
            {
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) == MEM
                  && GET_MODE (x5) == E_QImode)
                {
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  x7 = XEXP (x2, 1);
                  x8 = XEXP (x7, 0);
                  operands[2] = x8;
                  if (low_io_address_operand (operands[1], E_VOIDmode)
                      && 
#line 8193 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return gen_split_620 (insn, operands);
                  if (high_io_address_operand (operands[1], E_VOIDmode)
                      && 
#line 8287 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return gen_split_623 (insn, operands);
                }
            }
          if (GET_CODE (x3) != GE)
            return NULL;
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_QImode))
            return NULL;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!
#line 9089 "../../gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_633 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_QImode))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern307 (x6, 
E_HImode) != 0
              || !
#line 1907 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_114 (insn, operands);

        case E_HQmode:
          if (pattern307 (x6, 
E_HQmode) != 0
              || !
#line 1907 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_115 (insn, operands);

        case E_UHQmode:
          if (pattern307 (x6, 
E_UHQmode) != 0
              || !
#line 1907 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_116 (insn, operands);

        case E_HAmode:
          if (pattern307 (x6, 
E_HAmode) != 0
              || !
#line 1907 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_117 (insn, operands);

        case E_UHAmode:
          if (pattern307 (x6, 
E_UHAmode) != 0
              || !
#line 1907 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_118 (insn, operands);

        case E_SImode:
          if (pattern108 (x6, 
E_SImode) != 0
              || !
#line 1941 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_119 (insn, operands);

        case E_SQmode:
          if (pattern108 (x6, 
E_SQmode) != 0
              || !
#line 1941 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_120 (insn, operands);

        case E_USQmode:
          if (pattern108 (x6, 
E_USQmode) != 0
              || !
#line 1941 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_121 (insn, operands);

        case E_SAmode:
          if (pattern108 (x6, 
E_SAmode) != 0
              || !
#line 1941 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_122 (insn, operands);

        case E_USAmode:
          if (pattern108 (x6, 
E_USAmode) != 0
              || !
#line 1941 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_123 (insn, operands);

        case E_PSImode:
          if (pattern108 (x6, 
E_PSImode) != 0
              || !
#line 2051 "../../gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_147 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      operands[4] = x5;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          if (pattern231 (x6) != 0
              || !const_int_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_QImode)
              || !(
#line 2645 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2647 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_279 (insn, operands);

        case SIGN_EXTEND:
          if (pattern232 (x6) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2855 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2857 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_290 (insn, operands);
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2947 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)) && 
#line 2950 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_296 (insn, operands);

        case ZERO_EXTEND:
          if (GET_MODE (x10) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode
              || GET_MODE (x7) != E_HImode)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_QImode)
              || !u8_operand (operands[2], E_HImode)
              || !register_operand (operands[3], E_HImode)
              || !(
#line 2855 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2857 "../../gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_291 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_33 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_31 (x1, insn);

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case SUBREG:
            case MEM:
              switch (pattern172 (x1))
                {
                case 0:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_32 (insn, operands);

                case 1:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_33 (insn, operands);

                case 2:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_34 (insn, operands);

                case 3:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_35 (insn, operands);

                case 4:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_36 (insn, operands);

                case 5:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_37 (insn, operands);

                case 6:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_38 (insn, operands);

                case 7:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_39 (insn, operands);

                case 8:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_40 (insn, operands);

                case 9:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_41 (insn, operands);

                case 10:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_42 (insn, operands);

                case 11:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_43 (insn, operands);

                case 12:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_44 (insn, operands);

                case 13:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_45 (insn, operands);

                case 14:
                  if (!(
#line 674 "../../gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 679 "../../gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_46 (insn, operands);

                default:
                  return NULL;
                }

            case MULT:
              if (GET_MODE (x5) == E_SImode)
                {
                  res = split_28 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != REG
                  || pattern150 (x2) != 0
                  || pattern173 (x1) != 0)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_MODE (x7) != E_HImode)
                return NULL;
              switch (pattern360 (x1))
                {
                case 0:
                  if (!(
#line 3731 "../../gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY) && 
#line 3735 "../../gcc/config/avr/avr.md"
( reload_completed)))
                    return NULL;
                  return gen_split_336 (insn, operands);

                case 1:
                  if (!(
#line 4249 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4251 "../../gcc/config/avr/avr.md"
( reload_completed)))
                    return NULL;
                  return gen_split_358 (insn, operands);

                default:
                  return NULL;
                }

            case DIV:
              x8 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x8) != SET)
                return NULL;
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != MOD)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return NULL;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) == REG)
                {
                  res = split_29 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              if (REGNO (x7) != 26
                  || GET_MODE (x7) != E_QImode
                  || REGNO (x10) != 18
                  || GET_MODE (x10) != E_DImode
                  || pattern336 (x1) != 0)
                return NULL;
              return gen_split_359 (insn, operands);

            case UDIV:
              x8 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x8) != SET)
                return NULL;
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != UMOD)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              if (REGNO (x10) == 26
                  && GET_MODE (x10) == E_HImode)
                {
                  x6 = XEXP (x5, 0);
                  if (GET_CODE (x6) == REG
                      && pattern294 (x1) == 0)
                    {
                      x7 = XEXP (x4, 0);
                      if (GET_CODE (x7) == REG)
                        {
                          switch (REGNO (x6))
                            {
                            case 24:
                              if (pattern371 (x1, 
E_HImode, 
E_QImode, 
21, 
24, 
22) == 0
                                  && 
#line 4057 "../../gcc/config/avr/avr.md"
( reload_completed))
                                return gen_split_352 (insn, operands);
                              break;

                            case 22:
                              if (pattern371 (x1, 
E_SImode, 
E_HImode, 
30, 
22, 
18) == 0
                                  && 
#line 4456 "../../gcc/config/avr/avr.md"
( reload_completed))
                                return gen_split_366 (insn, operands);
                              break;

                            default:
                              break;
                            }
                        }
                    }
                }
              if (REGNO (x10) != 18
                  || GET_MODE (x10) != E_DImode)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 26
                  || GET_MODE (x7) != E_QImode
                  || pattern336 (x1) != 0)
                return NULL;
              return gen_split_361 (insn, operands);

            case UNSPEC:
              if (pattern119 (x1) != 0)
                return NULL;
              x7 = XEXP (x4, 0);
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x11 = XVECEXP (x5, 0, 0);
                  operands[0] = x11;
                  if (register_operand (operands[0], E_HImode))
                    {
                      x8 = XVECEXP (x1, 0, 1);
                      x12 = XEXP (x8, 0);
                      x13 = XEXP (x12, 0);
                      operands[1] = x13;
                      x10 = XEXP (x3, 0);
                      operands[2] = x10;
                      if (scratch_operand (operands[2], E_HImode)
                          && (
#line 7929 "../../gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL) && 
#line 7931 "../../gcc/config/avr/avr.md"
( reload_completed)))
                        return gen_split_616 (insn, operands);
                    }
                }
              x11 = XVECEXP (x5, 0, 0);
              if (GET_CODE (x11) != REG
                  || pattern325 (x1) != 0
                  || !(
#line 7965 "../../gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL) && 
#line 7967 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_617 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          return split_32 (x1, insn);

        case 7:
          if (pattern28 (x1) != 0)
            return NULL;
          switch (pattern385 (x1))
            {
            case 0:
              if (!
#line 1324 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_92 (insn, operands);

            case 1:
              if (!
#line 1324 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_93 (insn, operands);

            default:
              return NULL;
            }

        case 9:
          switch (pattern29 (x1))
            {
            case 0:
              if (!
#line 1380 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_94 (insn, operands);

            case 1:
              if (!
#line 1380 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_95 (insn, operands);

            default:
              return NULL;
            }

        case 5:
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x14 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x14) != CLOBBER)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x5 = XEXP (x2, 1);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                  if (XWINT (x5, 0) != 0L
                      || pattern174 (x1) != 0)
                    return NULL;
                  switch (pattern288 (x1))
                    {
                    case 0:
                      if (!
#line 1459 "../../gcc/config/avr/avr.md"
( reload_completed))
                        return NULL;
                      return gen_split_96 (insn, operands);

                    case 1:
                      if (!
#line 1490 "../../gcc/config/avr/avr.md"
( reload_completed))
                        return NULL;
                      return gen_split_97 (insn, operands);

                    default:
                      return NULL;
                    }

                case DIV:
                  if (pattern188 (x1, 
MOD) != 0
                      || !
#line 4309 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_360 (insn, operands);

                case UDIV:
                  if (pattern188 (x1, 
UMOD) != 0
                      || !
#line 4358 "../../gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_362 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (pattern158 (x1, 
3) != 0
                  || pattern248 (x1) != 0
                  || !
#line 8816 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_626 (insn, operands);

            default:
              return NULL;
            }

        case 6:
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x14 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x14) != CLOBBER)
            return NULL;
          x15 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x15) != CLOBBER)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return NULL;
              x16 = XEXP (x14, 0);
              if (GET_CODE (x16) != REG)
                return NULL;
              x17 = XEXP (x15, 0);
              if (GET_CODE (x17) != REG)
                return NULL;
              x18 = XEXP (x2, 0);
              operands[0] = x18;
              x12 = XEXP (x8, 0);
              operands[3] = x12;
              x5 = XEXP (x2, 1);
              switch (GET_CODE (x5))
                {
                case DIV:
                  switch (pattern344 (x1, 
MOD))
                    {
                    case 0:
                      return gen_split_345 (insn, operands);

                    case 1:
                      return gen_split_349 (insn, operands);

                    case 2:
                      return gen_split_363 (insn, operands);

                    default:
                      return NULL;
                    }

                case UDIV:
                  switch (pattern344 (x1, 
UMOD))
                    {
                    case 0:
                      return gen_split_347 (insn, operands);

                    case 1:
                      return gen_split_351 (insn, operands);

                    case 2:
                      return gen_split_365 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 2
                  || XINT (x2, 1) != 10)
                return NULL;
              x19 = XVECEXP (x2, 0, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return NULL;
              x9 = XEXP (x8, 1);
              if (pattern103 (x9) != 0
                  || pattern345 (x1) != 0
                  || !
#line 8859 "../../gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_627 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return peephole2_6 (x1, insn, pmatch_len_);

        case 3:
          if (peep2_current_count < 2)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 2);
          if (pattern116 (x4) != 0)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 2)
            return NULL;
          x7 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x7) != SET)
            return NULL;
          x8 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x8) != CLOBBER)
            return NULL;
          x9 = XEXP (x2, 1);
          switch (GET_CODE (x9))
            {
            case CONST_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
              operands[1] = x9;
              x10 = XEXP (x3, 0);
              operands[2] = x10;
              if (!d_register_operand (operands[2], E_QImode))
                return NULL;
              x11 = XEXP (x7, 1);
              if (GET_CODE (x11) != PLUS)
                return NULL;
              x12 = XEXP (x8, 0);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 36
                  || GET_MODE (x12) != E_CCmode)
                return NULL;
              x13 = XEXP (x7, 0);
              operands[3] = x13;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[3]))
                return NULL;
              x15 = XEXP (x11, 1);
              if (!rtx_equal_p (x15, operands[0]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern384 (x11, 
E_HImode) != 0
                      || !
#line 1890 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_37 (insn, operands);

                case E_HQmode:
                  if (pattern384 (x11, 
E_HQmode) != 0
                      || !
#line 1890 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_38 (insn, operands);

                case E_UHQmode:
                  if (pattern384 (x11, 
E_UHQmode) != 0
                      || !
#line 1890 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_39 (insn, operands);

                case E_HAmode:
                  if (pattern384 (x11, 
E_HAmode) != 0
                      || !
#line 1890 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_40 (insn, operands);

                case E_UHAmode:
                  if (pattern384 (x11, 
E_UHAmode) != 0
                      || !
#line 1890 "../../gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_41 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (peep2_current_count < 3)
                return NULL;
              x16 = XEXP (x9, 1);
              operands[1] = x16;
              x10 = XEXP (x3, 0);
              operands[3] = x10;
              if (!scratch_or_dreg_operand (operands[3], E_QImode))
                return NULL;
              x17 = XEXP (x9, 0);
              if (pattern372 (x17) != 0)
                return NULL;
              x12 = XEXP (x8, 0);
              if (GET_CODE (x12) != SCRATCH
                  || GET_MODE (x12) != E_QImode)
                return NULL;
              x11 = XEXP (x7, 1);
              x15 = XEXP (x11, 1);
              operands[4] = x15;
              x14 = XEXP (x11, 0);
              switch (pattern382 (x14))
                {
                case 0:
                  switch (pattern391 (x9, 
E_HImode))
                    {
                    case 0:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_152 (insn, operands);

                    case 1:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_153 (insn, operands);

                    case 2:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_154 (insn, operands);

                    case 3:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_155 (insn, operands);

                    case 4:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_156 (insn, operands);

                    case 5:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_157 (insn, operands);

                    default:
                      return NULL;
                    }

                case 1:
                  switch (pattern391 (x9, 
E_PSImode))
                    {
                    case 0:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_158 (insn, operands);

                    case 1:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_159 (insn, operands);

                    case 2:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_160 (insn, operands);

                    case 3:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_161 (insn, operands);

                    case 4:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_162 (insn, operands);

                    case 5:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_163 (insn, operands);

                    default:
                      return NULL;
                    }

                case 2:
                  switch (pattern391 (x9, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_164 (insn, operands);

                    case 1:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_165 (insn, operands);

                    case 2:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_166 (insn, operands);

                    case 3:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_167 (insn, operands);

                    case 4:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_168 (insn, operands);

                    case 5:
                      if (!
#line 7274 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_169 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case MINUS:
              if (peep2_current_count < 3)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != SCRATCH
                  || GET_MODE (x10) != E_QImode)
                return NULL;
              x16 = XEXP (x9, 1);
              operands[1] = x16;
              x17 = XEXP (x9, 0);
              if (pattern372 (x17) != 0
                  || pattern381 (x6) != 0)
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  switch (pattern392 (x9, 
E_HImode))
                    {
                    case 0:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_188 (insn, operands);

                    case 1:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_189 (insn, operands);

                    case 2:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_190 (insn, operands);

                    case 3:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_191 (insn, operands);

                    case 4:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_192 (insn, operands);

                    case 5:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_193 (insn, operands);

                    default:
                      return NULL;
                    }

                case E_SImode:
                  switch (pattern392 (x9, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_194 (insn, operands);

                    case 1:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_195 (insn, operands);

                    case 2:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_196 (insn, operands);

                    case 3:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_197 (insn, operands);

                    case 4:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_198 (insn, operands);

                    case 5:
                      if (!
#line 7379 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_199 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case ASHIFT:
              if (peep2_current_count < 3)
                return NULL;
              x16 = XEXP (x9, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x10 = XEXP (x3, 0);
              operands[3] = x10;
              if (!scratch_operand (operands[3], E_QImode))
                return NULL;
              x17 = XEXP (x9, 0);
              if (!rtx_equal_p (x17, operands[0]))
                return NULL;
              x11 = XEXP (x7, 1);
              if (GET_CODE (x11) != COMPARE
                  || GET_MODE (x11) != E_CCmode)
                return NULL;
              x15 = XEXP (x11, 1);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x13 = XEXP (x7, 0);
              if (GET_CODE (x13) != REG
                  || REGNO (x13) != 36
                  || GET_MODE (x13) != E_CCmode)
                return NULL;
              switch (pattern383 (x6))
                {
                case 0:
                  switch (pattern393 (x9, 
E_HImode))
                    {
                    case 0:
                      if (!
#line 7513 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_278 (insn, operands);

                    case 1:
                      if (!
#line 7513 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_279 (insn, operands);

                    default:
                      return NULL;
                    }

                case 1:
                  switch (pattern393 (x9, 
E_PSImode))
                    {
                    case 0:
                      if (!
#line 7513 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_280 (insn, operands);

                    case 1:
                      if (!
#line 7513 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_281 (insn, operands);

                    default:
                      return NULL;
                    }

                case 2:
                  switch (pattern393 (x9, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 7513 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_282 (insn, operands);

                    case 1:
                      if (!
#line 7513 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_283 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SET:
      if (peep2_current_count < 2)
        return NULL;
      x18 = XEXP (x1, 1);
      if (GET_CODE (x18) != COMPARE
          || pattern21 (x1) != 0)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern212 (x6) != 0)
        return NULL;
      x19 = XEXP (x18, 0);
      switch (GET_MODE (x19))
        {
        case E_QImode:
          if (!register_operand (x19, E_QImode))
            return NULL;
          operands[0] = x19;
          x20 = XEXP (x18, 1);
          switch (pattern348 (x20, 
E_QImode))
            {
            case 0:
              if (
#line 7730 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_290 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7730 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_291 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x19;
          if (pattern350 (x20, 
E_QImode) != 0
              || !
#line 10344 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_316 (insn, operands);

        case E_QQmode:
          if (!register_operand (x19, E_QQmode))
            return NULL;
          operands[0] = x19;
          x20 = XEXP (x18, 1);
          switch (pattern348 (x20, 
E_QQmode))
            {
            case 0:
              if (
#line 7730 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_292 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7730 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_293 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x19;
          if (pattern350 (x20, 
E_QQmode) != 0
              || !
#line 10344 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_317 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
