/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern7 (x2, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern7 (x2, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern7 (x2, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern7 (x2, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return 0;

    case SIGN_EXTEND:
      if (pattern16 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case ZERO_EXTEND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!const0_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          res = pattern9 ();
          if (res >= 0)
            return res + 2; /* [2, 5] */
          return -1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x2) != E_PSImode
              || GET_MODE (x3) != E_PSImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 6; /* [6, 9] */
              return -1;

            case E_HImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 10; /* [10, 13] */
              return -1;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 14; /* [14, 17] */
              return -1;

            case E_HImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 18; /* [18, 21] */
              return -1;

            case E_PSImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 22; /* [22, 25] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x2, 0);
      res = pattern30 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || !register_operand (operands[1], E_PSImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_QImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (XINT (x1, 1))
    {
    case 0:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != MEM
          || GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case 7:
      if (GET_MODE (x1) != E_QImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[1] = x2;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      operands[3] = x5;
      if (!nonmemory_operand (operands[3], E_QImode))
        return -1;
      return 1;

    case 8:
      x5 = XVECEXP (x1, 0, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[1] = x2;
      x3 = XVECEXP (x1, 0, 1);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QQmode:
          if (!register_operand (operands[0], E_QQmode)
              || GET_MODE (x1) != E_QQmode
              || !register_operand (operands[1], E_QQmode))
            return -1;
          return 2;

        case E_HQmode:
          if (!register_operand (operands[0], E_HQmode)
              || GET_MODE (x1) != E_HQmode
              || !register_operand (operands[1], E_HQmode))
            return -1;
          return 3;

        case E_HAmode:
          if (!register_operand (operands[0], E_HAmode)
              || GET_MODE (x1) != E_HAmode
              || !register_operand (operands[1], E_HAmode))
            return -1;
          return 4;

        case E_SAmode:
          if (!register_operand (operands[0], E_SAmode)
              || GET_MODE (x1) != E_SAmode
              || !register_operand (operands[1], E_SAmode))
            return -1;
          return 5;

        case E_SQmode:
          if (!register_operand (operands[0], E_SQmode)
              || GET_MODE (x1) != E_SQmode
              || !register_operand (operands[1], E_SQmode))
            return -1;
          return 6;

        case E_UQQmode:
          if (!register_operand (operands[0], E_UQQmode)
              || GET_MODE (x1) != E_UQQmode
              || !register_operand (operands[1], E_UQQmode))
            return -1;
          return 7;

        case E_UHQmode:
          if (!register_operand (operands[0], E_UHQmode)
              || GET_MODE (x1) != E_UHQmode
              || !register_operand (operands[1], E_UHQmode))
            return -1;
          return 8;

        case E_UHAmode:
          if (!register_operand (operands[0], E_UHAmode)
              || GET_MODE (x1) != E_UHAmode
              || !register_operand (operands[1], E_UHAmode))
            return -1;
          return 9;

        case E_USAmode:
          if (!register_operand (operands[0], E_USAmode)
              || GET_MODE (x1) != E_USAmode
              || !register_operand (operands[1], E_USAmode))
            return -1;
          return 10;

        case E_USQmode:
          if (!register_operand (operands[0], E_USQmode)
              || GET_MODE (x1) != E_USQmode
              || !register_operand (operands[1], E_USQmode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern98 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      return 0;

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      res = pattern97 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  return 0;
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      return pattern112 (x7); /* [-1, 0] */

    case E_HImode:
      if (pattern113 (x7, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_HQmode:
      if (pattern113 (x7, 
E_HQmode) != 0)
        return -1;
      return 2;

    case E_UHQmode:
      if (pattern113 (x7, 
E_UHQmode) != 0)
        return -1;
      return 3;

    case E_HAmode:
      if (pattern113 (x7, 
E_HAmode) != 0)
        return -1;
      return 4;

    case E_UHAmode:
      if (pattern113 (x7, 
E_UHAmode) != 0)
        return -1;
      return 5;

    case E_SImode:
      if (pattern114 (x7, 
E_SImode) != 0)
        return -1;
      return 6;

    case E_SQmode:
      if (pattern114 (x7, 
E_SQmode) != 0)
        return -1;
      return 7;

    case E_USQmode:
      if (pattern114 (x7, 
E_USQmode) != 0)
        return -1;
      return 8;

    case E_SAmode:
      if (pattern114 (x7, 
E_SAmode) != 0)
        return -1;
      return 9;

    case E_USAmode:
      if (pattern114 (x7, 
E_USAmode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[2], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern135 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[3], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !single_one_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !single_one_operand (operands[2], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !single_one_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1
      || pattern142 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern146 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      if (pnum_clobbers == NULL
          || REGNO (x4) != 22)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 24)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 22)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 24:
          return pattern143 (x1, 
E_QImode, 
25); /* [-1, 0] */

        case 22:
          if (pattern143 (x1, 
E_HImode, 
24) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (pnum_clobbers == NULL
          || REGNO (x4) != 18)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 22)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 18)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 22:
          if (pattern143 (x1, 
E_PSImode, 
18) != 0)
            return -1;
          return 2;

        case 18:
          if (pattern143 (x1, 
E_SImode, 
22) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 25:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      res = pattern145 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_PSImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!const_int_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  return 0;
}

int
pattern179 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 3;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 4;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 5;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 6;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 7;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 8;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 9;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern206 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || pattern205 (x1, 
E_HImode, 
i1, 
24, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern213 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_or_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_HImode
      || pattern217 (x1, 
E_HImode) != 0)
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[2], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[1], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern243 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_PSImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 18
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  if (!pseudo_register_operand (operands[0], E_PSImode))
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != E_PSImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!pseudo_register_operand (operands[1], E_PSImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  if (!pseudo_register_operand (operands[2], E_PSImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[3] = x13;
  if (!pseudo_register_operand (operands[3], E_PSImode))
    return -1;
  x14 = XEXP (x5, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x5, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

int
pattern250 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_HImode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !memory_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !memory_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !memory_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !memory_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !memory_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !memory_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !memory_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !memory_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !memory_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !memory_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_SFmode))
        return -1;
      return 13;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !memory_operand (operands[1], E_PSImode))
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case ZERO_EXTEND:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case REG:
    case SUBREG:
      operands[2] = x1;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern286 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (XWINT (x7, 0) != 8L)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != 36
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x3) != E_QImode
      || GET_MODE (x4) != E_HImode
      || GET_MODE (x5) != E_HImode)
    return -1;
  x11 = XEXP (x5, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern294 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_CODE (x9) != REG)
    return -1;
  x10 = XEXP (x6, 0);
  if (GET_CODE (x10) != REG)
    return -1;
  return 0;
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern306 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != i4)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 24)
    return -1;
  return pattern277 (x1, 
i1, 
i2, 
i3); /* [-1, 3] */
}

int
pattern313 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !const_int_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 3)
    return -1;
  return pattern312 (x1, 
i1); /* [-1, 2] */
}

int
pattern316 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2
      || pattern315 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern319 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != COMPARE
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern328 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!l_register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!l_register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!l_register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern334 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22
      || GET_MODE (x5) != E_SImode
      || pattern309 (x1, 
E_QImode, 
26, 
22) != 0)
    return -1;
  return 0;
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 25
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  return pattern144 (x6); /* [-1, 1] */
}

int
pattern340 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2
      || GET_MODE (x7) != E_HImode
      || pattern140 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern345 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  if (!const_int_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  x13 = XEXP (x12, 0);
  operands[5] = x13;
  if (!scratch_operand (operands[5], E_QImode))
    return -1;
  x14 = XEXP (x4, 1);
  x15 = XVECEXP (x14, 0, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  return 0;
}

int
pattern358 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      return pattern357 (x1, 
SIGN_EXTEND); /* [-1, 0] */

    case ZERO_EXTEND:
      if (pattern357 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern365 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern374 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  switch (REGNO (x5))
    {
    case 24:
      return pattern373 (x1, 
E_QImode, 
23, 
22, 
25); /* [-1, 0] */

    case 22:
      if (pattern373 (x1, 
E_HImode, 
21, 
26, 
24) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern380 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1)
      || !const_int_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1)
      || !const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern384 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!l_register_operand (operands[0], i1)
      || !const_operand (operands[1], i1)
      || !l_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern389 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern387 (x1); /* [-1, 0] */

    case NE:
      if (pattern387 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern387 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern387 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern387 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern387 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LO_SUM
      || GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      if (
#line 640 "../../gcc/config/avr/avr.md"
(1 == 1
   && avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)))
        return 50; /* xmovqi_8 */
      if (pnum_clobbers == NULL
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 53; /* fmovqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x2) != E_QQmode)
        return -1;
      if (
#line 640 "../../gcc/config/avr/avr.md"
(1 == 1
   && avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)))
        return 51; /* xmovqq_8 */
      if (pnum_clobbers == NULL
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 54; /* fmovqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x2) != E_UQQmode)
        return -1;
      if (
#line 640 "../../gcc/config/avr/avr.md"
(1 == 1
   && avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)))
        return 52; /* xmovuqq_8 */
      if (pnum_clobbers == NULL
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 55; /* fmovuqq */

    case E_HImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 56; /* fmovhi */

    case E_HQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_HQmode)
          || GET_MODE (x2) != E_HQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 57; /* fmovhq */

    case E_UHQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_UHQmode)
          || GET_MODE (x2) != E_UHQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 58; /* fmovuhq */

    case E_HAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_HAmode)
          || GET_MODE (x2) != E_HAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 59; /* fmovha */

    case E_UHAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_UHAmode)
          || GET_MODE (x2) != E_UHAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 60; /* fmovuha */

    case E_SImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 61; /* fmovsi */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SQmode)
          || GET_MODE (x2) != E_SQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 62; /* fmovsq */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_USQmode)
          || GET_MODE (x2) != E_USQmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 63; /* fmovusq */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SAmode)
          || GET_MODE (x2) != E_SAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 64; /* fmovsa */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_USAmode)
          || GET_MODE (x2) != E_USAmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 65; /* fmovusa */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 66; /* fmovsf */

    case E_PSImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !
#line 655 "../../gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false)))
        return -1;
      *pnum_clobbers = 1;
      return 67; /* fmovpsi */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern194 (x2) != 0)
            return -1;
          if (
#line 2465 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 479; /* umulqihi3_split */
          if (pnum_clobbers == NULL
              || !
#line 2478 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 481; /* umulqihi3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || !pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              switch (pattern196 (
E_QImode))
                {
                case 0:
                  if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 551; /* *uumulqiqisi3 */

                case 1:
                  if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 559; /* *uumulqihisi3 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern196 (
E_HImode))
                {
                case 0:
                  if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 555; /* *uumulhiqisi3 */

                case 1:
                  if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 563; /* *uumulhihisi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_PSImode:
          switch (pattern195 (x2))
            {
            case 0:
              if (
#line 4108 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 596; /* *umulqihipsi3_split */
              if (pnum_clobbers == NULL
                  || !
#line 4121 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 597; /* *umulqihipsi3 */

            case 1:
              if (
#line 4135 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 598; /* *umulhiqipsi3_split */
              if (pnum_clobbers == NULL
                  || !
#line 4148 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 599; /* *umulhiqipsi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern197 (x2, pnum_clobbers))
        {
        case 0:
          if (
#line 2488 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 482; /* usmulqihi3 */
          if (pnum_clobbers == NULL
              || !
#line 2501 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 483; /* *usmulqihi3 */

        case 1:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 549; /* *usmulqiqisi3 */

        case 2:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 557; /* *usmulqihisi3 */

        case 3:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 553; /* *usmulhiqisi3 */

        case 4:
          if (!
#line 3646 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 561; /* *usmulhihisi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      if (register_operand (operands[0], E_HImode))
        {
          res = recog_11 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x3;
      if (!pseudo_register_or_const_int_operand (operands[2], E_SImode)
          || !pseudo_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!pseudo_register_operand (operands[1], E_QImode)
              || !
#line 3483 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 543; /* *muluqisi3 */

        case E_HImode:
          if (!pseudo_register_operand (operands[1], E_HImode)
              || !
#line 3483 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 544; /* *muluhisi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern21 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (register_operand (operands[1], E_QImode)
          && const0_operand (operands[0], E_QImode)
          && 
#line 6733 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 828; /* *swapped_tstqi */
      if (register_operand (operands[1], E_QQmode)
          && const0_operand (operands[0], E_QQmode)
          && 
#line 6733 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 829; /* *swapped_tstqq */
      if (register_operand (operands[1], E_HImode)
          && const0_operand (operands[0], E_HImode)
          && 
#line 6743 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 830; /* *swapped_tsthi */
      if (register_operand (operands[1], E_HQmode)
          && const0_operand (operands[0], E_HQmode)
          && 
#line 6743 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 831; /* *swapped_tsthq */
      if (register_operand (operands[1], E_HAmode)
          && const0_operand (operands[0], E_HAmode)
          && 
#line 6743 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 832; /* *swapped_tstha */
      if (register_operand (operands[1], E_SImode)
          && const0_operand (operands[0], E_SImode)
          && 
#line 6763 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 834; /* *swapped_tstsi */
      if (register_operand (operands[1], E_SQmode)
          && const0_operand (operands[0], E_SQmode)
          && 
#line 6763 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 835; /* *swapped_tstsq */
      if (register_operand (operands[1], E_SAmode)
          && const0_operand (operands[0], E_SAmode)
          && 
#line 6763 "../../gcc/config/avr/avr.md"
(reload_completed))
        return 836; /* *swapped_tstsa */
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x4;
      if (!register_operand (operands[0], E_PSImode)
          || !
#line 6753 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 833; /* *swapped_tstpsi */

    case REG:
    case SUBREG:
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && nonmemory_operand (operands[1], E_QImode)
                  && 
#line 6777 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 837; /* cmpqi3 */
              break;

            case E_QQmode:
              if (register_operand (operands[0], E_QQmode)
                  && nonmemory_operand (operands[1], E_QQmode)
                  && 
#line 6777 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 838; /* cmpqq3 */
              break;

            case E_UQQmode:
              if (register_operand (operands[0], E_UQQmode)
                  && nonmemory_operand (operands[1], E_UQQmode)
                  && 
#line 6777 "../../gcc/config/avr/avr.md"
(reload_completed))
                return 839; /* cmpuqq3 */
              break;

            case E_HImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_HImode)
                  && nonmemory_operand (operands[1], E_HImode)
                  && 
#line 6819 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 864; /* cmphi3 */
                }
              break;

            case E_HQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_HQmode)
                  && nonmemory_operand (operands[1], E_HQmode)
                  && 
#line 6819 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 865; /* cmphq3 */
                }
              break;

            case E_UHQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_UHQmode)
                  && nonmemory_operand (operands[1], E_UHQmode)
                  && 
#line 6819 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 866; /* cmpuhq3 */
                }
              break;

            case E_HAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_HAmode)
                  && nonmemory_operand (operands[1], E_HAmode)
                  && 
#line 6819 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 867; /* cmpha3 */
                }
              break;

            case E_UHAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_UHAmode)
                  && nonmemory_operand (operands[1], E_UHAmode)
                  && 
#line 6819 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 868; /* cmpuha3 */
                }
              break;

            case E_PSImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_PSImode)
                  && nonmemory_operand (operands[1], E_PSImode)
                  && 
#line 6854 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 869; /* *cmppsi */
                }
              break;

            case E_SImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_SImode)
                  && nonmemory_operand (operands[1], E_SImode)
                  && 
#line 6886 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 870; /* *cmpsi */
                }
              break;

            case E_SQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_SQmode)
                  && nonmemory_operand (operands[1], E_SQmode)
                  && 
#line 6886 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 871; /* *cmpsq */
                }
              break;

            case E_USQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_USQmode)
                  && nonmemory_operand (operands[1], E_USQmode)
                  && 
#line 6886 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 872; /* *cmpusq */
                }
              break;

            case E_SAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_SAmode)
                  && nonmemory_operand (operands[1], E_SAmode)
                  && 
#line 6886 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 873; /* *cmpsa */
                }
              break;

            case E_USAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_USAmode)
                  && nonmemory_operand (operands[1], E_USAmode)
                  && 
#line 6886 "../../gcc/config/avr/avr.md"
(reload_completed))
                {
                  *pnum_clobbers = 1;
                  return 874; /* *cmpusa */
                }
              break;

            default:
              break;
            }
          break;

        case SIGN_EXTEND:
          switch (pattern229 (x4))
            {
            case 0:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return 852; /* *cmphi.sign_extendqi.1 */
              break;

            case 1:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return 854; /* *cmppsi.sign_extendqi.1 */
              break;

            case 2:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return 858; /* *cmppsi.sign_extendhi.1 */
              break;

            case 3:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return 856; /* *cmpsi.sign_extendqi.1 */
              break;

            case 4:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return 860; /* *cmpsi.sign_extendhi.1 */
              break;

            case 5:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return 862; /* *cmpsi.sign_extendpsi.1 */
              break;

            default:
              break;
            }
          break;

        case ZERO_EXTEND:
          switch (pattern229 (x4))
            {
            case 0:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return 853; /* *cmphi.zero_extendqi.1 */
              break;

            case 1:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return 855; /* *cmppsi.zero_extendqi.1 */
              break;

            case 2:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return 859; /* *cmppsi.zero_extendhi.1 */
              break;

            case 3:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return 857; /* *cmpsi.zero_extendqi.1 */
              break;

            case 4:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return 861; /* *cmpsi.zero_extendhi.1 */
              break;

            case 5:
              if (
#line 6803 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return 863; /* *cmpsi.zero_extendpsi.1 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 18)
        return -1;
      switch (GET_CODE (x4))
        {
        case REG:
          if (REGNO (x4) != 10)
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (GET_MODE (x4) != E_DImode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3281; /* compare_di2 */

            case E_DQmode:
              if (GET_MODE (x4) != E_DQmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3282; /* compare_dq2 */

            case E_UDQmode:
              if (GET_MODE (x4) != E_UDQmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3283; /* compare_udq2 */

            case E_DAmode:
              if (GET_MODE (x4) != E_DAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3284; /* compare_da2 */

            case E_UDAmode:
              if (GET_MODE (x4) != E_UDAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3285; /* compare_uda2 */

            case E_TAmode:
              if (GET_MODE (x4) != E_TAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3286; /* compare_ta2 */

            case E_UTAmode:
              if (GET_MODE (x4) != E_UTAmode
                  || !
#line 518 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
                return -1;
              return 3287; /* compare_uta2 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern249 (x4, 
E_QImode, 
E_DImode) != 0
              || GET_MODE (x3) != E_DImode
              || !
#line 543 "../../gcc/config/avr/avr-dimode.md"
(reload_completed && avr_have_dimode))
            return -1;
          return 3289; /* compare_const8_di2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern203 (x2))
        {
        case 0:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 840; /* *cmphi.sign_extendqi.0 */

        case 1:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 842; /* *cmppsi.sign_extendqi.0 */

        case 2:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 846; /* *cmppsi.sign_extendhi.0 */

        case 3:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 844; /* *cmpsi.sign_extendqi.0 */

        case 4:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 848; /* *cmpsi.sign_extendhi.0 */

        case 5:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 850; /* *cmpsi.sign_extendpsi.0 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern203 (x2))
        {
        case 0:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 841; /* *cmphi.zero_extendqi.0 */

        case 1:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 843; /* *cmppsi.zero_extendqi.0 */

        case 2:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 847; /* *cmppsi.zero_extendhi.0 */

        case 3:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 845; /* *cmpsi.zero_extendqi.0 */

        case 4:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 849; /* *cmpsi.zero_extendhi.0 */

        case 5:
          if (!
#line 6790 "../../gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 851; /* *cmpsi.zero_extendpsi.0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case MEM:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) == POST_DEC
          && GET_MODE (x3) == E_HImode)
        {
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 32
              && GET_MODE (x4) == E_HImode)
            {
              x5 = XEXP (x1, 1);
              operands[0] = x5;
              switch (GET_MODE (x2))
                {
                case E_QImode:
                  if (reg_or_0_operand (operands[0], E_QImode))
                    return 1; /* pushqi1 */
                  break;

                case E_QQmode:
                  if (reg_or_0_operand (operands[0], E_QQmode))
                    return 2; /* pushqq1 */
                  break;

                case E_UQQmode:
                  if (reg_or_0_operand (operands[0], E_UQQmode))
                    return 3; /* pushuqq1 */
                  break;

                case E_HImode:
                  if (reg_or_0_operand (operands[0], E_HImode))
                    return 4; /* pushhi1_insn */
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case REG:
    case SUBREG:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case SUBREG:
    case MEM:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LABEL_REF:
      if (GET_CODE (x2) == PC)
        {
          x6 = XEXP (x5, 0);
          operands[0] = x6;
          return 969; /* jump */
        }
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      operands[0] = x5;
      if (nonmemory_operand (operands[0], E_HImode))
        return 973; /* *indirect_jump */
      break;

    default:
      break;
    }
  operands[0] = x2;
  if (GET_MODE (x5) != E_QImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case SUBREG:
      switch (pattern123 (x5))
        {
        case 0:
          if (register_operand (operands[0], E_QImode))
            return 677; /* *ashlsqihiqi3 */
          if (!memory_operand (operands[0], E_QImode)
              || !
#line 5405 "../../gcc/config/avr/avr.md"
(!reload_completed))
            return -1;
          return 679; /* *ashlsqihiqi3.mem */

        case 1:
          if (register_operand (operands[0], E_QImode))
            return 678; /* *ashluqihiqi3 */
          if (!memory_operand (operands[0], E_QImode)
              || !
#line 5405 "../../gcc/config/avr/avr.md"
(!reload_completed))
            return -1;
          return 680; /* *ashluqihiqi3.mem */

        case 2:
          if (!
#line 5423 "../../gcc/config/avr/avr.md"
(!reload_completed))
            return -1;
          return 681; /* *ashlhiqi3 */

        case 3:
          return 1015; /* mask1_0x80_split */

        case 4:
          if (!
#line 10466 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1157; /* *extzv.subreg.hi */

        case 5:
          if (!
#line 10466 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1158; /* *extzv.subreg.psi */

        case 6:
          if (!
#line 10466 "../../gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1159; /* *extzv.subreg.si */

        case 7:
          return 1021; /* *split.flash_segment */

        default:
          return -1;
        }

    case MEM:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != PRE_INC
          || GET_MODE (x6) != E_HImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 32
          || GET_MODE (x7) != E_HImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      return 994; /* popqi */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x8 = XEXP (x3, 2);
  operands[1] = x8;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x9 = XEXP (x2, 1);
  operands[2] = x9;
  if (!nonmemory_operand (operands[2], E_QImode)
      || !
#line 10013 "../../gcc/config/avr/avr.md"
(reload_completed))
    return -1;
  return 1079; /* *insv.reg */
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x4, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (pattern322 (x1) != 0
          || !
#line 2478 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 480; /* mulqihi3 */

    case ZERO_EXTEND:
      if (pattern322 (x1) != 0
          || !
#line 2526 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 485; /* *sumulqihi3 */

    case CONST_INT:
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      if (s8_operand (operands[2], E_HImode)
          && 
#line 2994 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 521; /* *mulsqihi3.sconst */
      if (u8_operand (operands[2], E_HImode)
          && 
#line 3030 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 524; /* *mulsqihi3.uconst */
      if (!o8_operand (operands[2], E_HImode)
          || !
#line 3048 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 525; /* *mulsqihi3.oconst */

    case REG:
    case SUBREG:
      if (pattern223 (x1) != 0
          || !
#line 3162 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 532; /* *mulsqihi3 */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern235 (x1))
        {
        case 0:
          if (
#line 5337 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 664; /* *ashlqi3 */
          break;

        case 1:
          if (
#line 5337 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 665; /* *ashlqq3 */
          break;

        case 2:
          if (
#line 5337 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 666; /* *ashluqq3 */
          break;

        case 3:
          if (
#line 5369 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 672; /* *ashlhi3 */
          break;

        case 4:
          if (
#line 5369 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 673; /* *ashlhq3 */
          break;

        case 5:
          if (
#line 5369 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 674; /* *ashluhq3 */
          break;

        case 6:
          if (
#line 5369 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 675; /* *ashlha3 */
          break;

        case 7:
          if (
#line 5369 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 676; /* *ashluha3 */
          break;

        case 8:
          if (
#line 5482 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 687; /* *ashlsi3 */
          break;

        case 9:
          if (
#line 5482 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 688; /* *ashlsq3 */
          break;

        case 10:
          if (
#line 5482 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 689; /* *ashlusq3 */
          break;

        case 11:
          if (
#line 5482 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 690; /* *ashlsa3 */
          break;

        case 12:
          if (
#line 5482 "../../gcc/config/avr/avr.md"
(reload_completed))
            return 691; /* *ashlusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SImode) != 0
          || !
#line 5670 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 697; /* *ashlsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SQmode) != 0
          || !
#line 5670 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 698; /* *ashlsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_USQmode) != 0
          || !
#line 5670 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 699; /* *ashlusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_SAmode) != 0
          || !
#line 5670 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 700; /* *ashlsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern114 (x4, 
E_USAmode) != 0
          || !
#line 5670 "../../gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 701; /* *ashlusa3_const */

    case E_PSImode:
      if (pattern112 (x4) != 0)
        return -1;
      return 702; /* *ashlpsi3_split */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode
   && reload_completed))
        return -1;
      return 2636; /* *fractunsuqqqq2 */

    case 1:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QQmode
   && reload_completed))
        return -1;
      return 2637; /* *fractunshqqq2 */

    case 2:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode
   && reload_completed))
        return -1;
      return 2638; /* *fractunsuhqqq2 */

    case 3:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QQmode
   && reload_completed))
        return -1;
      return 2639; /* *fractunshaqq2 */

    case 4:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode
   && reload_completed))
        return -1;
      return 2640; /* *fractunsuhaqq2 */

    case 5:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QQmode
   && reload_completed))
        return -1;
      return 2641; /* *fractunssqqq2 */

    case 6:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QQmode
   && reload_completed))
        return -1;
      return 2642; /* *fractunsusqqq2 */

    case 7:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QQmode
   && reload_completed))
        return -1;
      return 2643; /* *fractunssaqq2 */

    case 8:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QQmode
   && reload_completed))
        return -1;
      return 2644; /* *fractunsusaqq2 */

    case 9:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QQmode
   && reload_completed))
        return -1;
      return 2645; /* *fractunsdqqq2 */

    case 10:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode
   && reload_completed))
        return -1;
      return 2646; /* *fractunsudqqq2 */

    case 11:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QQmode
   && reload_completed))
        return -1;
      return 2647; /* *fractunsdaqq2 */

    case 12:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode
   && reload_completed))
        return -1;
      return 2648; /* *fractunsudaqq2 */

    case 13:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QQmode
   && reload_completed))
        return -1;
      return 2649; /* *fractunstaqq2 */

    case 14:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode
   && reload_completed))
        return -1;
      return 2650; /* *fractunsutaqq2 */

    case 15:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != QQmode
   && reload_completed))
        return -1;
      return 2651; /* *fractunsqiqq2 */

    case 16:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != QQmode
   && reload_completed))
        return -1;
      return 2652; /* *fractunshiqq2 */

    case 17:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != QQmode
   && reload_completed))
        return -1;
      return 2653; /* *fractunssiqq2 */

    case 18:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != QQmode
   && reload_completed))
        return -1;
      return 2654; /* *fractunsdiqq2 */

    case 19:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode
   && reload_completed))
        return -1;
      return 2655; /* *fractunsqquqq2 */

    case 20:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode
   && reload_completed))
        return -1;
      return 2656; /* *fractunshquqq2 */

    case 21:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode
   && reload_completed))
        return -1;
      return 2657; /* *fractunsuhquqq2 */

    case 22:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode
   && reload_completed))
        return -1;
      return 2658; /* *fractunshauqq2 */

    case 23:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode
   && reload_completed))
        return -1;
      return 2659; /* *fractunsuhauqq2 */

    case 24:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode
   && reload_completed))
        return -1;
      return 2660; /* *fractunssquqq2 */

    case 25:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode
   && reload_completed))
        return -1;
      return 2661; /* *fractunsusquqq2 */

    case 26:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode
   && reload_completed))
        return -1;
      return 2662; /* *fractunssauqq2 */

    case 27:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode
   && reload_completed))
        return -1;
      return 2663; /* *fractunsusauqq2 */

    case 28:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode
   && reload_completed))
        return -1;
      return 2664; /* *fractunsdquqq2 */

    case 29:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode
   && reload_completed))
        return -1;
      return 2665; /* *fractunsudquqq2 */

    case 30:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode
   && reload_completed))
        return -1;
      return 2666; /* *fractunsdauqq2 */

    case 31:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode
   && reload_completed))
        return -1;
      return 2667; /* *fractunsudauqq2 */

    case 32:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode
   && reload_completed))
        return -1;
      return 2668; /* *fractunstauqq2 */

    case 33:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode
   && reload_completed))
        return -1;
      return 2669; /* *fractunsutauqq2 */

    case 34:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UQQmode
   && reload_completed))
        return -1;
      return 2670; /* *fractunsqiuqq2 */

    case 35:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UQQmode
   && reload_completed))
        return -1;
      return 2671; /* *fractunshiuqq2 */

    case 36:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UQQmode
   && reload_completed))
        return -1;
      return 2672; /* *fractunssiuqq2 */

    case 37:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UQQmode
   && reload_completed))
        return -1;
      return 2673; /* *fractunsdiuqq2 */

    case 38:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HQmode
   && reload_completed))
        return -1;
      return 2674; /* *fractunsqqhq2 */

    case 39:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode
   && reload_completed))
        return -1;
      return 2675; /* *fractunsuqqhq2 */

    case 40:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode
   && reload_completed))
        return -1;
      return 2676; /* *fractunsuhqhq2 */

    case 41:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HQmode
   && reload_completed))
        return -1;
      return 2677; /* *fractunshahq2 */

    case 42:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode
   && reload_completed))
        return -1;
      return 2678; /* *fractunsuhahq2 */

    case 43:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HQmode
   && reload_completed))
        return -1;
      return 2679; /* *fractunssqhq2 */

    case 44:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HQmode
   && reload_completed))
        return -1;
      return 2680; /* *fractunsusqhq2 */

    case 45:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HQmode
   && reload_completed))
        return -1;
      return 2681; /* *fractunssahq2 */

    case 46:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HQmode
   && reload_completed))
        return -1;
      return 2682; /* *fractunsusahq2 */

    case 47:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HQmode
   && reload_completed))
        return -1;
      return 2683; /* *fractunsdqhq2 */

    case 48:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode
   && reload_completed))
        return -1;
      return 2684; /* *fractunsudqhq2 */

    case 49:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HQmode
   && reload_completed))
        return -1;
      return 2685; /* *fractunsdahq2 */

    case 50:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode
   && reload_completed))
        return -1;
      return 2686; /* *fractunsudahq2 */

    case 51:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HQmode
   && reload_completed))
        return -1;
      return 2687; /* *fractunstahq2 */

    case 52:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode
   && reload_completed))
        return -1;
      return 2688; /* *fractunsutahq2 */

    case 53:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != HQmode
   && reload_completed))
        return -1;
      return 2689; /* *fractunsqihq2 */

    case 54:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != HQmode
   && reload_completed))
        return -1;
      return 2690; /* *fractunshihq2 */

    case 55:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != HQmode
   && reload_completed))
        return -1;
      return 2691; /* *fractunssihq2 */

    case 56:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != HQmode
   && reload_completed))
        return -1;
      return 2692; /* *fractunsdihq2 */

    case 57:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode
   && reload_completed))
        return -1;
      return 2693; /* *fractunsqquhq2 */

    case 58:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode
   && reload_completed))
        return -1;
      return 2694; /* *fractunsuqquhq2 */

    case 59:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode
   && reload_completed))
        return -1;
      return 2695; /* *fractunshquhq2 */

    case 60:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode
   && reload_completed))
        return -1;
      return 2696; /* *fractunshauhq2 */

    case 61:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode
   && reload_completed))
        return -1;
      return 2697; /* *fractunsuhauhq2 */

    case 62:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode
   && reload_completed))
        return -1;
      return 2698; /* *fractunssquhq2 */

    case 63:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode
   && reload_completed))
        return -1;
      return 2699; /* *fractunsusquhq2 */

    case 64:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode
   && reload_completed))
        return -1;
      return 2700; /* *fractunssauhq2 */

    case 65:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode
   && reload_completed))
        return -1;
      return 2701; /* *fractunsusauhq2 */

    case 66:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode
   && reload_completed))
        return -1;
      return 2702; /* *fractunsdquhq2 */

    case 67:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode
   && reload_completed))
        return -1;
      return 2703; /* *fractunsudquhq2 */

    case 68:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode
   && reload_completed))
        return -1;
      return 2704; /* *fractunsdauhq2 */

    case 69:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode
   && reload_completed))
        return -1;
      return 2705; /* *fractunsudauhq2 */

    case 70:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode
   && reload_completed))
        return -1;
      return 2706; /* *fractunstauhq2 */

    case 71:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode
   && reload_completed))
        return -1;
      return 2707; /* *fractunsutauhq2 */

    case 72:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHQmode
   && reload_completed))
        return -1;
      return 2708; /* *fractunsqiuhq2 */

    case 73:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHQmode
   && reload_completed))
        return -1;
      return 2709; /* *fractunshiuhq2 */

    case 74:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHQmode
   && reload_completed))
        return -1;
      return 2710; /* *fractunssiuhq2 */

    case 75:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHQmode
   && reload_completed))
        return -1;
      return 2711; /* *fractunsdiuhq2 */

    case 76:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HAmode
   && reload_completed))
        return -1;
      return 2712; /* *fractunsqqha2 */

    case 77:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode
   && reload_completed))
        return -1;
      return 2713; /* *fractunsuqqha2 */

    case 78:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HAmode
   && reload_completed))
        return -1;
      return 2714; /* *fractunshqha2 */

    case 79:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode
   && reload_completed))
        return -1;
      return 2715; /* *fractunsuhqha2 */

    case 80:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode
   && reload_completed))
        return -1;
      return 2716; /* *fractunsuhaha2 */

    case 81:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HAmode
   && reload_completed))
        return -1;
      return 2717; /* *fractunssqha2 */

    case 82:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HAmode
   && reload_completed))
        return -1;
      return 2718; /* *fractunsusqha2 */

    case 83:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HAmode
   && reload_completed))
        return -1;
      return 2719; /* *fractunssaha2 */

    case 84:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HAmode
   && reload_completed))
        return -1;
      return 2720; /* *fractunsusaha2 */

    case 85:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HAmode
   && reload_completed))
        return -1;
      return 2721; /* *fractunsdqha2 */

    case 86:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode
   && reload_completed))
        return -1;
      return 2722; /* *fractunsudqha2 */

    case 87:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HAmode
   && reload_completed))
        return -1;
      return 2723; /* *fractunsdaha2 */

    case 88:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode
   && reload_completed))
        return -1;
      return 2724; /* *fractunsudaha2 */

    case 89:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HAmode
   && reload_completed))
        return -1;
      return 2725; /* *fractunstaha2 */

    case 90:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode
   && reload_completed))
        return -1;
      return 2726; /* *fractunsutaha2 */

    case 91:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != HAmode
   && reload_completed))
        return -1;
      return 2727; /* *fractunsqiha2 */

    case 92:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != HAmode
   && reload_completed))
        return -1;
      return 2728; /* *fractunshiha2 */

    case 93:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != HAmode
   && reload_completed))
        return -1;
      return 2729; /* *fractunssiha2 */

    case 94:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != HAmode
   && reload_completed))
        return -1;
      return 2730; /* *fractunsdiha2 */

    case 95:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode
   && reload_completed))
        return -1;
      return 2731; /* *fractunsqquha2 */

    case 96:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode
   && reload_completed))
        return -1;
      return 2732; /* *fractunsuqquha2 */

    case 97:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode
   && reload_completed))
        return -1;
      return 2733; /* *fractunshquha2 */

    case 98:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode
   && reload_completed))
        return -1;
      return 2734; /* *fractunsuhquha2 */

    case 99:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode
   && reload_completed))
        return -1;
      return 2735; /* *fractunshauha2 */

    case 100:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode
   && reload_completed))
        return -1;
      return 2736; /* *fractunssquha2 */

    case 101:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode
   && reload_completed))
        return -1;
      return 2737; /* *fractunsusquha2 */

    case 102:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode
   && reload_completed))
        return -1;
      return 2738; /* *fractunssauha2 */

    case 103:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode
   && reload_completed))
        return -1;
      return 2739; /* *fractunsusauha2 */

    case 104:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode
   && reload_completed))
        return -1;
      return 2740; /* *fractunsdquha2 */

    case 105:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode
   && reload_completed))
        return -1;
      return 2741; /* *fractunsudquha2 */

    case 106:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode
   && reload_completed))
        return -1;
      return 2742; /* *fractunsdauha2 */

    case 107:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode
   && reload_completed))
        return -1;
      return 2743; /* *fractunsudauha2 */

    case 108:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode
   && reload_completed))
        return -1;
      return 2744; /* *fractunstauha2 */

    case 109:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode
   && reload_completed))
        return -1;
      return 2745; /* *fractunsutauha2 */

    case 110:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UHAmode
   && reload_completed))
        return -1;
      return 2746; /* *fractunsqiuha2 */

    case 111:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UHAmode
   && reload_completed))
        return -1;
      return 2747; /* *fractunshiuha2 */

    case 112:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UHAmode
   && reload_completed))
        return -1;
      return 2748; /* *fractunssiuha2 */

    case 113:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UHAmode
   && reload_completed))
        return -1;
      return 2749; /* *fractunsdiuha2 */

    case 114:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SQmode
   && reload_completed))
        return -1;
      return 2750; /* *fractunsqqsq2 */

    case 115:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode
   && reload_completed))
        return -1;
      return 2751; /* *fractunsuqqsq2 */

    case 116:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SQmode
   && reload_completed))
        return -1;
      return 2752; /* *fractunshqsq2 */

    case 117:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode
   && reload_completed))
        return -1;
      return 2753; /* *fractunsuhqsq2 */

    case 118:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SQmode
   && reload_completed))
        return -1;
      return 2754; /* *fractunshasq2 */

    case 119:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode
   && reload_completed))
        return -1;
      return 2755; /* *fractunsuhasq2 */

    case 120:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SQmode
   && reload_completed))
        return -1;
      return 2756; /* *fractunsusqsq2 */

    case 121:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SQmode
   && reload_completed))
        return -1;
      return 2757; /* *fractunssasq2 */

    case 122:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SQmode
   && reload_completed))
        return -1;
      return 2758; /* *fractunsusasq2 */

    case 123:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SQmode
   && reload_completed))
        return -1;
      return 2759; /* *fractunsdqsq2 */

    case 124:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode
   && reload_completed))
        return -1;
      return 2760; /* *fractunsudqsq2 */

    case 125:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SQmode
   && reload_completed))
        return -1;
      return 2761; /* *fractunsdasq2 */

    case 126:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode
   && reload_completed))
        return -1;
      return 2762; /* *fractunsudasq2 */

    case 127:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SQmode
   && reload_completed))
        return -1;
      return 2763; /* *fractunstasq2 */

    case 128:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode
   && reload_completed))
        return -1;
      return 2764; /* *fractunsutasq2 */

    case 129:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != SQmode
   && reload_completed))
        return -1;
      return 2765; /* *fractunsqisq2 */

    case 130:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != SQmode
   && reload_completed))
        return -1;
      return 2766; /* *fractunshisq2 */

    case 131:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != SQmode
   && reload_completed))
        return -1;
      return 2767; /* *fractunssisq2 */

    case 132:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != SQmode
   && reload_completed))
        return -1;
      return 2768; /* *fractunsdisq2 */

    case 133:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USQmode
   && reload_completed))
        return -1;
      return 2769; /* *fractunsqqusq2 */

    case 134:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode
   && reload_completed))
        return -1;
      return 2770; /* *fractunsuqqusq2 */

    case 135:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USQmode
   && reload_completed))
        return -1;
      return 2771; /* *fractunshqusq2 */

    case 136:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode
   && reload_completed))
        return -1;
      return 2772; /* *fractunsuhqusq2 */

    case 137:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USQmode
   && reload_completed))
        return -1;
      return 2773; /* *fractunshausq2 */

    case 138:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode
   && reload_completed))
        return -1;
      return 2774; /* *fractunsuhausq2 */

    case 139:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USQmode
   && reload_completed))
        return -1;
      return 2775; /* *fractunssqusq2 */

    case 140:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USQmode
   && reload_completed))
        return -1;
      return 2776; /* *fractunssausq2 */

    case 141:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != USQmode
   && reload_completed))
        return -1;
      return 2777; /* *fractunsusausq2 */

    case 142:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USQmode
   && reload_completed))
        return -1;
      return 2778; /* *fractunsdqusq2 */

    case 143:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode
   && reload_completed))
        return -1;
      return 2779; /* *fractunsudqusq2 */

    case 144:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USQmode
   && reload_completed))
        return -1;
      return 2780; /* *fractunsdausq2 */

    case 145:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode
   && reload_completed))
        return -1;
      return 2781; /* *fractunsudausq2 */

    case 146:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USQmode
   && reload_completed))
        return -1;
      return 2782; /* *fractunstausq2 */

    case 147:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode
   && reload_completed))
        return -1;
      return 2783; /* *fractunsutausq2 */

    case 148:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != USQmode
   && reload_completed))
        return -1;
      return 2784; /* *fractunsqiusq2 */

    case 149:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != USQmode
   && reload_completed))
        return -1;
      return 2785; /* *fractunshiusq2 */

    case 150:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != USQmode
   && reload_completed))
        return -1;
      return 2786; /* *fractunssiusq2 */

    case 151:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != USQmode
   && reload_completed))
        return -1;
      return 2787; /* *fractunsdiusq2 */

    case 152:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SAmode
   && reload_completed))
        return -1;
      return 2788; /* *fractunsqqsa2 */

    case 153:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode
   && reload_completed))
        return -1;
      return 2789; /* *fractunsuqqsa2 */

    case 154:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SAmode
   && reload_completed))
        return -1;
      return 2790; /* *fractunshqsa2 */

    case 155:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode
   && reload_completed))
        return -1;
      return 2791; /* *fractunsuhqsa2 */

    case 156:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SAmode
   && reload_completed))
        return -1;
      return 2792; /* *fractunshasa2 */

    case 157:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode
   && reload_completed))
        return -1;
      return 2793; /* *fractunsuhasa2 */

    case 158:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SAmode
   && reload_completed))
        return -1;
      return 2794; /* *fractunssqsa2 */

    case 159:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SAmode
   && reload_completed))
        return -1;
      return 2795; /* *fractunsusqsa2 */

    case 160:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SAmode
   && reload_completed))
        return -1;
      return 2796; /* *fractunsusasa2 */

    case 161:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SAmode
   && reload_completed))
        return -1;
      return 2797; /* *fractunsdqsa2 */

    case 162:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode
   && reload_completed))
        return -1;
      return 2798; /* *fractunsudqsa2 */

    case 163:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SAmode
   && reload_completed))
        return -1;
      return 2799; /* *fractunsdasa2 */

    case 164:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode
   && reload_completed))
        return -1;
      return 2800; /* *fractunsudasa2 */

    case 165:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SAmode
   && reload_completed))
        return -1;
      return 2801; /* *fractunstasa2 */

    case 166:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode
   && reload_completed))
        return -1;
      return 2802; /* *fractunsutasa2 */

    case 167:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != SAmode
   && reload_completed))
        return -1;
      return 2803; /* *fractunsqisa2 */

    case 168:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != SAmode
   && reload_completed))
        return -1;
      return 2804; /* *fractunshisa2 */

    case 169:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != SAmode
   && reload_completed))
        return -1;
      return 2805; /* *fractunssisa2 */

    case 170:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != SAmode
   && reload_completed))
        return -1;
      return 2806; /* *fractunsdisa2 */

    case 171:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != USAmode
   && reload_completed))
        return -1;
      return 2807; /* *fractunsqqusa2 */

    case 172:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode
   && reload_completed))
        return -1;
      return 2808; /* *fractunsuqqusa2 */

    case 173:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != USAmode
   && reload_completed))
        return -1;
      return 2809; /* *fractunshqusa2 */

    case 174:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode
   && reload_completed))
        return -1;
      return 2810; /* *fractunsuhqusa2 */

    case 175:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != USAmode
   && reload_completed))
        return -1;
      return 2811; /* *fractunshausa2 */

    case 176:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode
   && reload_completed))
        return -1;
      return 2812; /* *fractunsuhausa2 */

    case 177:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != USAmode
   && reload_completed))
        return -1;
      return 2813; /* *fractunssqusa2 */

    case 178:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != USAmode
   && reload_completed))
        return -1;
      return 2814; /* *fractunsusqusa2 */

    case 179:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != USAmode
   && reload_completed))
        return -1;
      return 2815; /* *fractunssausa2 */

    case 180:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != USAmode
   && reload_completed))
        return -1;
      return 2816; /* *fractunsdqusa2 */

    case 181:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode
   && reload_completed))
        return -1;
      return 2817; /* *fractunsudqusa2 */

    case 182:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != USAmode
   && reload_completed))
        return -1;
      return 2818; /* *fractunsdausa2 */

    case 183:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode
   && reload_completed))
        return -1;
      return 2819; /* *fractunsudausa2 */

    case 184:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != USAmode
   && reload_completed))
        return -1;
      return 2820; /* *fractunstausa2 */

    case 185:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode
   && reload_completed))
        return -1;
      return 2821; /* *fractunsutausa2 */

    case 186:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != USAmode
   && reload_completed))
        return -1;
      return 2822; /* *fractunsqiusa2 */

    case 187:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != USAmode
   && reload_completed))
        return -1;
      return 2823; /* *fractunshiusa2 */

    case 188:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != USAmode
   && reload_completed))
        return -1;
      return 2824; /* *fractunssiusa2 */

    case 189:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != USAmode
   && reload_completed))
        return -1;
      return 2825; /* *fractunsdiusa2 */

    case 190:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DQmode
   && reload_completed))
        return -1;
      return 2826; /* *fractunsqqdq2 */

    case 191:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode
   && reload_completed))
        return -1;
      return 2827; /* *fractunsuqqdq2 */

    case 192:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DQmode
   && reload_completed))
        return -1;
      return 2828; /* *fractunshqdq2 */

    case 193:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode
   && reload_completed))
        return -1;
      return 2829; /* *fractunsuhqdq2 */

    case 194:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DQmode
   && reload_completed))
        return -1;
      return 2830; /* *fractunshadq2 */

    case 195:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode
   && reload_completed))
        return -1;
      return 2831; /* *fractunsuhadq2 */

    case 196:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DQmode
   && reload_completed))
        return -1;
      return 2832; /* *fractunssqdq2 */

    case 197:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DQmode
   && reload_completed))
        return -1;
      return 2833; /* *fractunsusqdq2 */

    case 198:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DQmode
   && reload_completed))
        return -1;
      return 2834; /* *fractunssadq2 */

    case 199:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DQmode
   && reload_completed))
        return -1;
      return 2835; /* *fractunsusadq2 */

    case 200:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode
   && reload_completed))
        return -1;
      return 2836; /* *fractunsudqdq2 */

    case 201:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DQmode
   && reload_completed))
        return -1;
      return 2837; /* *fractunsdadq2 */

    case 202:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode
   && reload_completed))
        return -1;
      return 2838; /* *fractunsudadq2 */

    case 203:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DQmode
   && reload_completed))
        return -1;
      return 2839; /* *fractunstadq2 */

    case 204:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode
   && reload_completed))
        return -1;
      return 2840; /* *fractunsutadq2 */

    case 205:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != DQmode
   && reload_completed))
        return -1;
      return 2841; /* *fractunsqidq2 */

    case 206:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != DQmode
   && reload_completed))
        return -1;
      return 2842; /* *fractunshidq2 */

    case 207:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != DQmode
   && reload_completed))
        return -1;
      return 2843; /* *fractunssidq2 */

    case 208:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != DQmode
   && reload_completed))
        return -1;
      return 2844; /* *fractunsdidq2 */

    case 209:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode
   && reload_completed))
        return -1;
      return 2845; /* *fractunsqqudq2 */

    case 210:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode
   && reload_completed))
        return -1;
      return 2846; /* *fractunsuqqudq2 */

    case 211:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode
   && reload_completed))
        return -1;
      return 2847; /* *fractunshqudq2 */

    case 212:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode
   && reload_completed))
        return -1;
      return 2848; /* *fractunsuhqudq2 */

    case 213:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode
   && reload_completed))
        return -1;
      return 2849; /* *fractunshaudq2 */

    case 214:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode
   && reload_completed))
        return -1;
      return 2850; /* *fractunsuhaudq2 */

    case 215:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode
   && reload_completed))
        return -1;
      return 2851; /* *fractunssqudq2 */

    case 216:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode
   && reload_completed))
        return -1;
      return 2852; /* *fractunsusqudq2 */

    case 217:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode
   && reload_completed))
        return -1;
      return 2853; /* *fractunssaudq2 */

    case 218:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode
   && reload_completed))
        return -1;
      return 2854; /* *fractunsusaudq2 */

    case 219:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode
   && reload_completed))
        return -1;
      return 2855; /* *fractunsdqudq2 */

    case 220:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode
   && reload_completed))
        return -1;
      return 2856; /* *fractunsdaudq2 */

    case 221:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode
   && reload_completed))
        return -1;
      return 2857; /* *fractunsudaudq2 */

    case 222:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode
   && reload_completed))
        return -1;
      return 2858; /* *fractunstaudq2 */

    case 223:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode
   && reload_completed))
        return -1;
      return 2859; /* *fractunsutaudq2 */

    case 224:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDQmode
   && reload_completed))
        return -1;
      return 2860; /* *fractunsqiudq2 */

    case 225:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDQmode
   && reload_completed))
        return -1;
      return 2861; /* *fractunshiudq2 */

    case 226:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDQmode
   && reload_completed))
        return -1;
      return 2862; /* *fractunssiudq2 */

    case 227:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDQmode
   && reload_completed))
        return -1;
      return 2863; /* *fractunsdiudq2 */

    case 228:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DAmode
   && reload_completed))
        return -1;
      return 2864; /* *fractunsqqda2 */

    case 229:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode
   && reload_completed))
        return -1;
      return 2865; /* *fractunsuqqda2 */

    case 230:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DAmode
   && reload_completed))
        return -1;
      return 2866; /* *fractunshqda2 */

    case 231:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode
   && reload_completed))
        return -1;
      return 2867; /* *fractunsuhqda2 */

    case 232:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DAmode
   && reload_completed))
        return -1;
      return 2868; /* *fractunshada2 */

    case 233:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode
   && reload_completed))
        return -1;
      return 2869; /* *fractunsuhada2 */

    case 234:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DAmode
   && reload_completed))
        return -1;
      return 2870; /* *fractunssqda2 */

    case 235:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DAmode
   && reload_completed))
        return -1;
      return 2871; /* *fractunsusqda2 */

    case 236:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DAmode
   && reload_completed))
        return -1;
      return 2872; /* *fractunssada2 */

    case 237:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DAmode
   && reload_completed))
        return -1;
      return 2873; /* *fractunsusada2 */

    case 238:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DAmode
   && reload_completed))
        return -1;
      return 2874; /* *fractunsdqda2 */

    case 239:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode
   && reload_completed))
        return -1;
      return 2875; /* *fractunsudqda2 */

    case 240:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode
   && reload_completed))
        return -1;
      return 2876; /* *fractunsudada2 */

    case 241:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DAmode
   && reload_completed))
        return -1;
      return 2877; /* *fractunstada2 */

    case 242:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode
   && reload_completed))
        return -1;
      return 2878; /* *fractunsutada2 */

    case 243:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != DAmode
   && reload_completed))
        return -1;
      return 2879; /* *fractunsqida2 */

    case 244:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != DAmode
   && reload_completed))
        return -1;
      return 2880; /* *fractunshida2 */

    case 245:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != DAmode
   && reload_completed))
        return -1;
      return 2881; /* *fractunssida2 */

    case 246:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != DAmode
   && reload_completed))
        return -1;
      return 2882; /* *fractunsdida2 */

    case 247:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode
   && reload_completed))
        return -1;
      return 2883; /* *fractunsqquda2 */

    case 248:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode
   && reload_completed))
        return -1;
      return 2884; /* *fractunsuqquda2 */

    case 249:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode
   && reload_completed))
        return -1;
      return 2885; /* *fractunshquda2 */

    case 250:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode
   && reload_completed))
        return -1;
      return 2886; /* *fractunsuhquda2 */

    case 251:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode
   && reload_completed))
        return -1;
      return 2887; /* *fractunshauda2 */

    case 252:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode
   && reload_completed))
        return -1;
      return 2888; /* *fractunsuhauda2 */

    case 253:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode
   && reload_completed))
        return -1;
      return 2889; /* *fractunssquda2 */

    case 254:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode
   && reload_completed))
        return -1;
      return 2890; /* *fractunsusquda2 */

    case 255:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode
   && reload_completed))
        return -1;
      return 2891; /* *fractunssauda2 */

    case 256:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode
   && reload_completed))
        return -1;
      return 2892; /* *fractunsusauda2 */

    case 257:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode
   && reload_completed))
        return -1;
      return 2893; /* *fractunsdquda2 */

    case 258:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode
   && reload_completed))
        return -1;
      return 2894; /* *fractunsudquda2 */

    case 259:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode
   && reload_completed))
        return -1;
      return 2895; /* *fractunsdauda2 */

    case 260:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode
   && reload_completed))
        return -1;
      return 2896; /* *fractunstauda2 */

    case 261:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode
   && reload_completed))
        return -1;
      return 2897; /* *fractunsutauda2 */

    case 262:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UDAmode
   && reload_completed))
        return -1;
      return 2898; /* *fractunsqiuda2 */

    case 263:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UDAmode
   && reload_completed))
        return -1;
      return 2899; /* *fractunshiuda2 */

    case 264:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UDAmode
   && reload_completed))
        return -1;
      return 2900; /* *fractunssiuda2 */

    case 265:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UDAmode
   && reload_completed))
        return -1;
      return 2901; /* *fractunsdiuda2 */

    case 266:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != TAmode
   && reload_completed))
        return -1;
      return 2902; /* *fractunsqqta2 */

    case 267:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode
   && reload_completed))
        return -1;
      return 2903; /* *fractunsuqqta2 */

    case 268:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != TAmode
   && reload_completed))
        return -1;
      return 2904; /* *fractunshqta2 */

    case 269:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode
   && reload_completed))
        return -1;
      return 2905; /* *fractunsuhqta2 */

    case 270:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != TAmode
   && reload_completed))
        return -1;
      return 2906; /* *fractunshata2 */

    case 271:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode
   && reload_completed))
        return -1;
      return 2907; /* *fractunsuhata2 */

    case 272:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != TAmode
   && reload_completed))
        return -1;
      return 2908; /* *fractunssqta2 */

    case 273:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != TAmode
   && reload_completed))
        return -1;
      return 2909; /* *fractunsusqta2 */

    case 274:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != TAmode
   && reload_completed))
        return -1;
      return 2910; /* *fractunssata2 */

    case 275:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != TAmode
   && reload_completed))
        return -1;
      return 2911; /* *fractunsusata2 */

    case 276:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != TAmode
   && reload_completed))
        return -1;
      return 2912; /* *fractunsdqta2 */

    case 277:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode
   && reload_completed))
        return -1;
      return 2913; /* *fractunsudqta2 */

    case 278:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != TAmode
   && reload_completed))
        return -1;
      return 2914; /* *fractunsdata2 */

    case 279:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode
   && reload_completed))
        return -1;
      return 2915; /* *fractunsudata2 */

    case 280:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode
   && reload_completed))
        return -1;
      return 2916; /* *fractunsutata2 */

    case 281:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != TAmode
   && reload_completed))
        return -1;
      return 2917; /* *fractunsqita2 */

    case 282:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != TAmode
   && reload_completed))
        return -1;
      return 2918; /* *fractunshita2 */

    case 283:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != TAmode
   && reload_completed))
        return -1;
      return 2919; /* *fractunssita2 */

    case 284:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != TAmode
   && reload_completed))
        return -1;
      return 2920; /* *fractunsdita2 */

    case 285:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode
   && reload_completed))
        return -1;
      return 2921; /* *fractunsqquta2 */

    case 286:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode
   && reload_completed))
        return -1;
      return 2922; /* *fractunsuqquta2 */

    case 287:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode
   && reload_completed))
        return -1;
      return 2923; /* *fractunshquta2 */

    case 288:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode
   && reload_completed))
        return -1;
      return 2924; /* *fractunsuhquta2 */

    case 289:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode
   && reload_completed))
        return -1;
      return 2925; /* *fractunshauta2 */

    case 290:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode
   && reload_completed))
        return -1;
      return 2926; /* *fractunsuhauta2 */

    case 291:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode
   && reload_completed))
        return -1;
      return 2927; /* *fractunssquta2 */

    case 292:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode
   && reload_completed))
        return -1;
      return 2928; /* *fractunsusquta2 */

    case 293:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode
   && reload_completed))
        return -1;
      return 2929; /* *fractunssauta2 */

    case 294:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode
   && reload_completed))
        return -1;
      return 2930; /* *fractunsusauta2 */

    case 295:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode
   && reload_completed))
        return -1;
      return 2931; /* *fractunsdquta2 */

    case 296:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode
   && reload_completed))
        return -1;
      return 2932; /* *fractunsudquta2 */

    case 297:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode
   && reload_completed))
        return -1;
      return 2933; /* *fractunsdauta2 */

    case 298:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode
   && reload_completed))
        return -1;
      return 2934; /* *fractunsudauta2 */

    case 299:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode
   && reload_completed))
        return -1;
      return 2935; /* *fractunstauta2 */

    case 300:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != UTAmode
   && reload_completed))
        return -1;
      return 2936; /* *fractunsqiuta2 */

    case 301:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != UTAmode
   && reload_completed))
        return -1;
      return 2937; /* *fractunshiuta2 */

    case 302:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != UTAmode
   && reload_completed))
        return -1;
      return 2938; /* *fractunssiuta2 */

    case 303:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != UTAmode
   && reload_completed))
        return -1;
      return 2939; /* *fractunsdiuta2 */

    case 304:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != QImode
   && reload_completed))
        return -1;
      return 2940; /* *fractunsqqqi2 */

    case 305:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != QImode
   && reload_completed))
        return -1;
      return 2941; /* *fractunsuqqqi2 */

    case 306:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != QImode
   && reload_completed))
        return -1;
      return 2942; /* *fractunshqqi2 */

    case 307:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != QImode
   && reload_completed))
        return -1;
      return 2943; /* *fractunsuhqqi2 */

    case 308:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != QImode
   && reload_completed))
        return -1;
      return 2944; /* *fractunshaqi2 */

    case 309:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != QImode
   && reload_completed))
        return -1;
      return 2945; /* *fractunsuhaqi2 */

    case 310:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != QImode
   && reload_completed))
        return -1;
      return 2946; /* *fractunssqqi2 */

    case 311:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != QImode
   && reload_completed))
        return -1;
      return 2947; /* *fractunsusqqi2 */

    case 312:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != QImode
   && reload_completed))
        return -1;
      return 2948; /* *fractunssaqi2 */

    case 313:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != QImode
   && reload_completed))
        return -1;
      return 2949; /* *fractunsusaqi2 */

    case 314:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != QImode
   && reload_completed))
        return -1;
      return 2950; /* *fractunsdqqi2 */

    case 315:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != QImode
   && reload_completed))
        return -1;
      return 2951; /* *fractunsudqqi2 */

    case 316:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != QImode
   && reload_completed))
        return -1;
      return 2952; /* *fractunsdaqi2 */

    case 317:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != QImode
   && reload_completed))
        return -1;
      return 2953; /* *fractunsudaqi2 */

    case 318:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != QImode
   && reload_completed))
        return -1;
      return 2954; /* *fractunstaqi2 */

    case 319:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != QImode
   && reload_completed))
        return -1;
      return 2955; /* *fractunsutaqi2 */

    case 320:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != QImode
   && reload_completed))
        return -1;
      return 2956; /* *fractunshiqi2 */

    case 321:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != QImode
   && reload_completed))
        return -1;
      return 2957; /* *fractunssiqi2 */

    case 322:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != QImode
   && reload_completed))
        return -1;
      return 2958; /* *fractunsdiqi2 */

    case 323:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != HImode
   && reload_completed))
        return -1;
      return 2959; /* *fractunsqqhi2 */

    case 324:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != HImode
   && reload_completed))
        return -1;
      return 2960; /* *fractunsuqqhi2 */

    case 325:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != HImode
   && reload_completed))
        return -1;
      return 2961; /* *fractunshqhi2 */

    case 326:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != HImode
   && reload_completed))
        return -1;
      return 2962; /* *fractunsuhqhi2 */

    case 327:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != HImode
   && reload_completed))
        return -1;
      return 2963; /* *fractunshahi2 */

    case 328:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != HImode
   && reload_completed))
        return -1;
      return 2964; /* *fractunsuhahi2 */

    case 329:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != HImode
   && reload_completed))
        return -1;
      return 2965; /* *fractunssqhi2 */

    case 330:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != HImode
   && reload_completed))
        return -1;
      return 2966; /* *fractunsusqhi2 */

    case 331:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != HImode
   && reload_completed))
        return -1;
      return 2967; /* *fractunssahi2 */

    case 332:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != HImode
   && reload_completed))
        return -1;
      return 2968; /* *fractunsusahi2 */

    case 333:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != HImode
   && reload_completed))
        return -1;
      return 2969; /* *fractunsdqhi2 */

    case 334:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != HImode
   && reload_completed))
        return -1;
      return 2970; /* *fractunsudqhi2 */

    case 335:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != HImode
   && reload_completed))
        return -1;
      return 2971; /* *fractunsdahi2 */

    case 336:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != HImode
   && reload_completed))
        return -1;
      return 2972; /* *fractunsudahi2 */

    case 337:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != HImode
   && reload_completed))
        return -1;
      return 2973; /* *fractunstahi2 */

    case 338:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != HImode
   && reload_completed))
        return -1;
      return 2974; /* *fractunsutahi2 */

    case 339:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != HImode
   && reload_completed))
        return -1;
      return 2975; /* *fractunsqihi2 */

    case 340:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != HImode
   && reload_completed))
        return -1;
      return 2976; /* *fractunssihi2 */

    case 341:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != HImode
   && reload_completed))
        return -1;
      return 2977; /* *fractunsdihi2 */

    case 342:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != SImode
   && reload_completed))
        return -1;
      return 2978; /* *fractunsqqsi2 */

    case 343:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != SImode
   && reload_completed))
        return -1;
      return 2979; /* *fractunsuqqsi2 */

    case 344:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != SImode
   && reload_completed))
        return -1;
      return 2980; /* *fractunshqsi2 */

    case 345:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != SImode
   && reload_completed))
        return -1;
      return 2981; /* *fractunsuhqsi2 */

    case 346:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != SImode
   && reload_completed))
        return -1;
      return 2982; /* *fractunshasi2 */

    case 347:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != SImode
   && reload_completed))
        return -1;
      return 2983; /* *fractunsuhasi2 */

    case 348:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != SImode
   && reload_completed))
        return -1;
      return 2984; /* *fractunssqsi2 */

    case 349:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != SImode
   && reload_completed))
        return -1;
      return 2985; /* *fractunsusqsi2 */

    case 350:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != SImode
   && reload_completed))
        return -1;
      return 2986; /* *fractunssasi2 */

    case 351:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != SImode
   && reload_completed))
        return -1;
      return 2987; /* *fractunsusasi2 */

    case 352:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != SImode
   && reload_completed))
        return -1;
      return 2988; /* *fractunsdqsi2 */

    case 353:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != SImode
   && reload_completed))
        return -1;
      return 2989; /* *fractunsudqsi2 */

    case 354:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != SImode
   && reload_completed))
        return -1;
      return 2990; /* *fractunsdasi2 */

    case 355:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != SImode
   && reload_completed))
        return -1;
      return 2991; /* *fractunsudasi2 */

    case 356:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != SImode
   && reload_completed))
        return -1;
      return 2992; /* *fractunstasi2 */

    case 357:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != SImode
   && reload_completed))
        return -1;
      return 2993; /* *fractunsutasi2 */

    case 358:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != SImode
   && reload_completed))
        return -1;
      return 2994; /* *fractunsqisi2 */

    case 359:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != SImode
   && reload_completed))
        return -1;
      return 2995; /* *fractunshisi2 */

    case 360:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DImode != SImode
   && reload_completed))
        return -1;
      return 2996; /* *fractunsdisi2 */

    case 361:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QQmode != DImode
   && reload_completed))
        return -1;
      return 2997; /* *fractunsqqdi2 */

    case 362:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UQQmode != DImode
   && reload_completed))
        return -1;
      return 2998; /* *fractunsuqqdi2 */

    case 363:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HQmode != DImode
   && reload_completed))
        return -1;
      return 2999; /* *fractunshqdi2 */

    case 364:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHQmode != DImode
   && reload_completed))
        return -1;
      return 3000; /* *fractunsuhqdi2 */

    case 365:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HAmode != DImode
   && reload_completed))
        return -1;
      return 3001; /* *fractunshadi2 */

    case 366:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UHAmode != DImode
   && reload_completed))
        return -1;
      return 3002; /* *fractunsuhadi2 */

    case 367:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SQmode != DImode
   && reload_completed))
        return -1;
      return 3003; /* *fractunssqdi2 */

    case 368:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USQmode != DImode
   && reload_completed))
        return -1;
      return 3004; /* *fractunsusqdi2 */

    case 369:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SAmode != DImode
   && reload_completed))
        return -1;
      return 3005; /* *fractunssadi2 */

    case 370:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(USAmode != DImode
   && reload_completed))
        return -1;
      return 3006; /* *fractunsusadi2 */

    case 371:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DQmode != DImode
   && reload_completed))
        return -1;
      return 3007; /* *fractunsdqdi2 */

    case 372:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDQmode != DImode
   && reload_completed))
        return -1;
      return 3008; /* *fractunsudqdi2 */

    case 373:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(DAmode != DImode
   && reload_completed))
        return -1;
      return 3009; /* *fractunsdadi2 */

    case 374:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UDAmode != DImode
   && reload_completed))
        return -1;
      return 3010; /* *fractunsudadi2 */

    case 375:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(TAmode != DImode
   && reload_completed))
        return -1;
      return 3011; /* *fractunstadi2 */

    case 376:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(UTAmode != DImode
   && reload_completed))
        return -1;
      return 3012; /* *fractunsutadi2 */

    case 377:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(QImode != DImode
   && reload_completed))
        return -1;
      return 3013; /* *fractunsqidi2 */

    case 378:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(HImode != DImode
   && reload_completed))
        return -1;
      return 3014; /* *fractunshidi2 */

    case 379:
      if (!
#line 99 "../../gcc/config/avr/avr-fixed.md"
(SImode != DImode
   && reload_completed))
        return -1;
      return 3015; /* *fractunssidi2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (pattern153 (x3))
    {
    case 0:
      if (
#line 5771 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_503 (insn, operands);
      break;

    case 1:
      if (
#line 5771 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_504 (insn, operands);
      break;

    case 2:
      if (
#line 5771 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_505 (insn, operands);
      break;

    case 3:
      if (
#line 5798 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_506 (insn, operands);
      break;

    case 4:
      if (
#line 5798 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_507 (insn, operands);
      break;

    case 5:
      if (
#line 5798 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_508 (insn, operands);
      break;

    case 6:
      if (
#line 5798 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_509 (insn, operands);
      break;

    case 7:
      if (
#line 5798 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_510 (insn, operands);
      break;

    case 8:
      if (
#line 5861 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_512 (insn, operands);
      break;

    case 9:
      if (
#line 5861 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_513 (insn, operands);
      break;

    case 10:
      if (
#line 5861 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_514 (insn, operands);
      break;

    case 11:
      if (
#line 5861 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_515 (insn, operands);
      break;

    case 12:
      if (
#line 5861 "../../gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_516 (insn, operands);
      break;

    default:
      break;
    }
  if (GET_CODE (x4) != REG)
    return NULL;
  switch (pattern56 (x1))
    {
    case 0:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1936 (insn, operands);

    case 1:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1940 (insn, operands);

    case 2:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1944 (insn, operands);

    case 3:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1948 (insn, operands);

    case 4:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1952 (insn, operands);

    case 5:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1956 (insn, operands);

    case 6:
      if (!(
#line 629 "../../gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1960 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return NULL;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return NULL;
      operands[2] = x6;
      if (const_2_to_6_operand (operands[2], E_HImode)
          && register_operand (operands[0], E_HImode)
          && GET_MODE (x4) == E_HImode)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (register_operand (operands[1], E_QImode))
            {
              x8 = XVECEXP (x1, 0, 1);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (scratch_operand (operands[3], E_QImode)
                  && (
#line 3092 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3094 "../../gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_304 (insn, operands);
            }
        }
      if (XWINT (x6, 0) != 7L
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!scratch_operand (operands[2], E_QImode)
          || !(
#line 3110 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3112 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_305 (insn, operands);

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode
          || pattern224 (x1) != 0
          || !(
#line 3128 "../../gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3130 "../../gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_306 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern253 (x1))
            {
            case 0:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_437 (insn, operands);
              break;

            case 1:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_440 (insn, operands);
              break;

            case 2:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3l (operands[2])))
                return gen_split_443 (insn, operands);
              break;

            case 3:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_446 (insn, operands);
              break;

            case 4:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_449 (insn, operands);
              break;

            case 5:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_452 (insn, operands);
              break;

            case 6:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_455 (insn, operands);
              break;

            case 7:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_458 (insn, operands);
              break;

            case 8:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_461 (insn, operands);
              break;

            case 9:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_464 (insn, operands);
              break;

            case 10:
              if (
#line 5591 "../../gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_467 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern254 (x1) != 0
          || !
#line 5712 "../../gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_501 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode
      || !d_register_operand (operands[0], E_QImode))
    return NULL;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_QImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = PATTERN (peep2_next_insn (1));
  if (pattern316 (x6, 
E_QImode, 
AND) != 0)
    return NULL;
  x7 = XVECEXP (x6, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return NULL;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return NULL;
  x11 = XEXP (x7, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_42 (insn, operands);
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 0);
  if (pattern319 (x5) != 0)
    return NULL;
  x6 = PATTERN (peep2_next_insn (1));
  switch (pattern383 (x6))
    {
    case 0:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_HImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern394 (x12, 
E_HImode))
        {
        case 0:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_134 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_135 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_136 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_137 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_138 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_139 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern395 (x12, 
E_HImode))
        {
        case 0:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_170 (insn, operands);

        case 1:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_171 (insn, operands);

        case 2:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_172 (insn, operands);

        case 3:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_173 (insn, operands);

        case 4:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_174 (insn, operands);

        case 5:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_175 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_PSImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern394 (x12, 
E_PSImode))
        {
        case 0:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_140 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_141 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_142 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_143 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_144 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_145 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern395 (x12, 
E_PSImode))
        {
        case 0:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_176 (insn, operands);

        case 1:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_177 (insn, operands);

        case 2:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_178 (insn, operands);

        case 3:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_179 (insn, operands);

        case 4:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_180 (insn, operands);

        case 5:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_181 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_SImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern394 (x12, 
E_SImode))
        {
        case 0:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_146 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_147 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_148 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_149 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_150 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7246 "../../gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_151 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern395 (x12, 
E_SImode))
        {
        case 0:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_182 (insn, operands);

        case 1:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_183 (insn, operands);

        case 2:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_184 (insn, operands);

        case 3:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_185 (insn, operands);

        case 4:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_186 (insn, operands);

        case 5:
          if (!
#line 7309 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_187 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      res = peephole2_1 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      if (peep2_current_count < 2
          || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern209 (x1, 
E_QImode) != 0)
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (pattern316 (x5, 
E_QImode, 
IOR) != 0)
        return NULL;
      x6 = XVECEXP (x5, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return NULL;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_308 (insn, operands);

    case REG:
      return peephole2_5 (x1, insn, pmatch_len_);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      x11 = XEXP (x3, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 36
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XEXP (x2, 0);
      operands[0] = x12;
      switch (GET_CODE (x4))
        {
        case AND:
          res = peephole2_2 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case ASHIFT:
          x13 = XEXP (x4, 1);
          switch (GET_CODE (x13))
            {
            case REG:
            case SUBREG:
              operands[1] = x13;
              if (register_operand (operands[1], E_QImode)
                  && register_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode)
                {
                  x14 = XEXP (x4, 0);
                  if (rtx_equal_p (x14, operands[0]))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_85 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case CONST_INT:
              x14 = XEXP (x4, 0);
              if (rtx_equal_p (x14, operands[0]))
                {
                  switch (XWINT (x13, 0))
                    {
                    case 4L:
                      switch (pattern328 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_86 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_87 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_88 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 5L:
                      switch (pattern328 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_89 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_90 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_91 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 6L:
                      switch (pattern328 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_92 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_93 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_94 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x13;
              switch (pattern318 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_97 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_100 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_103 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_106 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_109 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_112 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_115 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_118 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_121 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_124 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case LSHIFTRT:
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) == CONST_INT)
            {
              operands[2] = x13;
              switch (pattern318 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_95 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_98 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_101 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_104 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_107 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_110 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_113 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_116 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_119 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_122 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
              x14 = XEXP (x4, 0);
              if (rtx_equal_p (x14, operands[0]))
                {
                  switch (XWINT (x13, 0))
                    {
                    case 4L:
                      switch (pattern328 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_125 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_126 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_127 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 5L:
                      switch (pattern328 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_128 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_129 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_130 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 6L:
                      switch (pattern328 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_131 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_132 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_133 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case ASHIFTRT:
          x14 = XEXP (x4, 0);
          operands[1] = x14;
          x13 = XEXP (x4, 1);
          operands[2] = x13;
          if (const_int_operand (operands[2], E_QImode))
            {
              switch (pattern317 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_96 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_99 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_102 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_105 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_108 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_111 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_114 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_117 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_120 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_123 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
            }
          break;

        case PLUS:
          res = peephole2_3 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case MINUS:
          res = peephole2_4 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (peep2_current_count < 2
          || peep2_current_count < 3
          || !register_operand (operands[0], E_QImode))
        return NULL;
      operands[2] = x4;
      if (!op8_ZN_operator (operands[2], E_QImode))
        return NULL;
      x13 = XEXP (x4, 1);
      operands[1] = x13;
      x14 = XEXP (x4, 0);
      if (!rtx_equal_p (x14, operands[0]))
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x5) != SET)
        return NULL;
      x15 = XEXP (x5, 1);
      if (GET_CODE (x15) != COMPARE
          || GET_MODE (x15) != E_CCmode)
        return NULL;
      x16 = XEXP (x5, 0);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 36
          || GET_MODE (x16) != E_CCmode)
        return NULL;
      x17 = XEXP (x15, 1);
      operands[4] = x17;
      if (!const0_operand (operands[4], E_QImode))
        return NULL;
      x18 = XEXP (x15, 0);
      if (!rtx_equal_p (x18, operands[0]))
        return NULL;
      x19 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x19) != SET)
        return NULL;
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != IF_THEN_ELSE)
        return NULL;
      x21 = XEXP (x20, 1);
      if (GET_CODE (x21) != LABEL_REF)
        return NULL;
      x22 = XEXP (x20, 2);
      if (GET_CODE (x22) != PC)
        return NULL;
      x23 = XEXP (x19, 0);
      if (GET_CODE (x23) != PC)
        return NULL;
      x24 = XEXP (x21, 0);
      operands[3] = x24;
      x25 = XEXP (x20, 0);
      switch (GET_CODE (x25))
        {
        case EQ:
          if (pattern387 (x25) != 0
              || !
#line 7562 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_284 (insn, operands);

        case NE:
          if (pattern387 (x25) != 0
              || !
#line 7562 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_285 (insn, operands);

        case GE:
          if (pattern387 (x25) != 0
              || !
#line 7562 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_286 (insn, operands);

        case LT:
          if (pattern387 (x25) != 0
              || !
#line 7562 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_287 (insn, operands);

        case GT:
          if (pattern387 (x25) != 0
              || !
#line 7562 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_288 (insn, operands);

        case LE:
          if (pattern387 (x25) != 0
              || !
#line 7562 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_289 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (peep2_current_count < 2
          || pattern107 (x2, 
36, 
E_CCmode) != 0)
        return NULL;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_QImode))
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (pattern212 (x5) != 0)
        return NULL;
      x14 = XEXP (x4, 0);
      switch (GET_MODE (x14))
        {
        case E_HImode:
          if (!register_operand (x14, E_HImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern377 (x13, 
E_HImode))
            {
            case 0:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_294 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_295 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern378 (x13, 
E_HImode) != 0
              || !
#line 10304 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_309 (insn, operands);

        case E_SImode:
          if (!register_operand (x14, E_SImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern377 (x13, 
E_SImode))
            {
            case 0:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_296 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_297 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern378 (x13, 
E_SImode) != 0
              || !
#line 10304 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_310 (insn, operands);

        case E_PSImode:
          if (!register_operand (x14, E_PSImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern377 (x13, 
E_PSImode))
            {
            case 0:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_298 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_299 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern378 (x13, 
E_PSImode) != 0
              || !
#line 10304 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_311 (insn, operands);

        case E_HQmode:
          if (!register_operand (x14, E_HQmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern377 (x13, 
E_HQmode))
            {
            case 0:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_300 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_301 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern378 (x13, 
E_HQmode) != 0
              || !
#line 10304 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_312 (insn, operands);

        case E_HAmode:
          if (!register_operand (x14, E_HAmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern377 (x13, 
E_HAmode))
            {
            case 0:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_302 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_303 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern378 (x13, 
E_HAmode) != 0
              || !
#line 10304 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_313 (insn, operands);

        case E_SQmode:
          if (!register_operand (x14, E_SQmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern377 (x13, 
E_SQmode))
            {
            case 0:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_304 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_305 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern378 (x13, 
E_SQmode) != 0
              || !
#line 10304 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_314 (insn, operands);

        case E_SAmode:
          if (!register_operand (x14, E_SAmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern377 (x13, 
E_SAmode))
            {
            case 0:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_306 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7755 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_307 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern378 (x13, 
E_SAmode) != 0
              || !
#line 10304 "../../gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_315 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
